#pragma once
#include "async.IStringHolder.ani.0.h"
#include "async.IStringHolder.proj.2.hpp"
inline ::async::IStringHolder async_IStringHolder_fromANI(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        ::taihe::string get() {
            ani_string ani_result;
            this->env->Object_CallMethodByName_Ref(this->ref, "get", nullptr, reinterpret_cast<ani_ref*>(&ani_result));

        ani_size cpp_result_len;
        this->env->String_GetUTF8Size(ani_result, &cpp_result_len);
        TString cpp_result_tstr;
        char* cpp_result_buf = tstr_initialize(&cpp_result_tstr, cpp_result_len + 1);
        this->env->String_GetUTF8(ani_result, cpp_result_buf, cpp_result_len + 1, &cpp_result_len);
        cpp_result_buf[cpp_result_len] = '\0';
        cpp_result_tstr.length = cpp_result_len;
        taihe::string cpp_result = taihe::string(cpp_result_tstr);
            return cpp_result;
        }
        void set(::taihe::string_view cpp_arg_a) {
        ani_string ani_arg_a;
        this->env->String_NewUTF8(cpp_arg_a.c_str(), cpp_arg_a.size(), &ani_arg_a);
            this->env->Object_CallMethodByName_Void(this->ref, "set", nullptr, ani_arg_a);

        }
    };
    return taihe::make_holder<cpp_impl_t, ::async::IStringHolder>(env, ani_obj);
}
inline ani_object async_IStringHolder_intoANI(ani_env* env, ::async::IStringHolder cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Lasync/IStringHolder_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
