#pragma once
#include "async.IStringHolder.proj.1.hpp"
#include "async.IStringHolder.abi.2.h"
#include "taihe/string.hpp"
namespace async::weak {
inline ::taihe::string IStringHolder::virtual_type::get() const& {
    return ::taihe::from_abi<::taihe::string>(async_IStringHolder_get_f(*reinterpret_cast<async_IStringHolder_t const*>(this)));
}
}
namespace async::weak {
inline void IStringHolder::virtual_type::set(::taihe::string_view a) const& {
    return async_IStringHolder_set_f(*reinterpret_cast<async_IStringHolder_t const*>(this), ::taihe::into_abi<::taihe::string_view>(a));
}
}
namespace async::weak {
template<typename Impl>
struct TString IStringHolder::methods_impl<Impl>::get(struct async_IStringHolder_t tobj) {
    return ::taihe::into_abi<::taihe::string>(::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->get());
}
}
namespace async::weak {
template<typename Impl>
void IStringHolder::methods_impl<Impl>::set(struct async_IStringHolder_t tobj, struct TString a) {
    return ::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->set(::taihe::from_abi<::taihe::string_view>(a));
}
}
