#include "async.ani.hpp"
#include "async.user.hpp"
#include "async.IStringHolder.ani.1.h"
static ani_int async_addSync_ANIFunc([[maybe_unused]] ani_env *env, ani_int ani_arg_a, ani_int ani_arg_b) {
    ::taihe::set_env(env);
    int32_t cpp_arg_a = (int32_t)ani_arg_a;
    int32_t cpp_arg_b = (int32_t)ani_arg_b;
    int32_t cpp_result = ::async::addSync(cpp_arg_a, cpp_arg_b);
    if (::taihe::has_error()) { return ani_int{}; }
    ani_int ani_result = (int32_t)cpp_result;
    return ani_result;
}
static ani_object async_makeIStringHolder_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::async::IStringHolder cpp_result = ::async::makeIStringHolder();
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = async_IStringHolder_intoANI(env, cpp_result);
    return ani_result;
}
static ani_string async_IStringHolder_get_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    async_IStringHolder_vtable* cpp_vtbl_ptr = reinterpret_cast<async_IStringHolder_vtable*>(ani_vtbl_ptr);
    ::async::weak::IStringHolder cpp_iface = ::async::weak::IStringHolder({cpp_vtbl_ptr, cpp_data_ptr});
    ::taihe::string cpp_result = ::async::weak::IStringHolder(cpp_iface)->get();
    if (::taihe::has_error()) { return ani_string{}; }
    ani_string ani_result;
    env->String_NewUTF8(cpp_result.c_str(), cpp_result.size(), &ani_result);
    return ani_result;
}
static void async_IStringHolder_set_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_string ani_arg_a) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    async_IStringHolder_vtable* cpp_vtbl_ptr = reinterpret_cast<async_IStringHolder_vtable*>(ani_vtbl_ptr);
    ::async::weak::IStringHolder cpp_iface = ::async::weak::IStringHolder({cpp_vtbl_ptr, cpp_data_ptr});
    ani_size cpp_arg_a_len;
    env->String_GetUTF8Size(ani_arg_a, &cpp_arg_a_len);
    TString cpp_arg_a_tstr;
    char* cpp_arg_a_buf = tstr_initialize(&cpp_arg_a_tstr, cpp_arg_a_len + 1);
    env->String_GetUTF8(ani_arg_a, cpp_arg_a_buf, cpp_arg_a_len + 1, &cpp_arg_a_len);
    cpp_arg_a_buf[cpp_arg_a_len] = '\0';
    cpp_arg_a_tstr.length = cpp_arg_a_len;
    taihe::string cpp_arg_a = taihe::string(cpp_arg_a_tstr);
    ::async::weak::IStringHolder(cpp_iface)->set(cpp_arg_a);
}
namespace async {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Lasync;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"addSync_inner", nullptr, reinterpret_cast<void*>(async_addSync_ANIFunc)},

            {"makeIStringHolder_inner", nullptr, reinterpret_cast<void*>(async_makeIStringHolder_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lasync/IStringHolder_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"get_inner", nullptr, reinterpret_cast<void*>(async_IStringHolder_get_ANIFunc)},

            {"set_inner", nullptr, reinterpret_cast<void*>(async_IStringHolder_set_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
