#pragma once
#include "taihe/common.hpp"
#include "callback.Person.proj.0.hpp"
#include "callback.Person.abi.1.h"
#include "taihe/string.hpp"
namespace callback {
struct Person {
    ::taihe::string name;
    int32_t age;
};
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::callback::Person const& val) -> ::std::size_t {
    ::std::size_t seed = 0;
    seed ^= hash(val.name) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.age) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    return seed;
}
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::callback::Person const& lhs, ::callback::Person const& rhs) {
    return true && same(lhs.name, rhs.name) && same(lhs.age, rhs.age);
}
}
namespace taihe {
template<>
struct as_abi<::callback::Person> {
    using type = struct callback_Person_t;
};
template<>
struct as_abi<::callback::Person const&> {
    using type = struct callback_Person_t const*;
};
template<>
struct as_param<::callback::Person> {
    using type = ::callback::Person const&;
};
}
