#pragma once
#include "ohos.book.store.Book.ani.0.h"
#include "ohos.book.store.Book.proj.1.hpp"
inline ::ohos::book::store::Book ohos_book_store_Book_fromANI(ani_env* env, ani_object ani_obj) {
    ani_string ani_field_title;
    env->Object_GetPropertyByName_Ref(ani_obj, "title", reinterpret_cast<ani_ref*>(&ani_field_title));

    ani_size cpp_field_title_len;
    env->String_GetUTF8Size(ani_field_title, &cpp_field_title_len);
    TString cpp_field_title_tstr;
    char* cpp_field_title_buf = tstr_initialize(&cpp_field_title_tstr, cpp_field_title_len + 1);
    env->String_GetUTF8(ani_field_title, cpp_field_title_buf, cpp_field_title_len + 1, &cpp_field_title_len);
    cpp_field_title_buf[cpp_field_title_len] = '\0';
    cpp_field_title_tstr.length = cpp_field_title_len;
    taihe::string cpp_field_title = taihe::string(cpp_field_title_tstr);
    ani_int ani_field_year;
    env->Object_GetPropertyByName_Int(ani_obj, "year", reinterpret_cast<ani_int*>(&ani_field_year));

    int32_t cpp_field_year = (int32_t)ani_field_year;
    ani_enum_item ani_field_category;
    env->Object_GetPropertyByName_Ref(ani_obj, "category", reinterpret_cast<ani_ref*>(&ani_field_category));

    ani_size cpp_field_category_ani;
    env->EnumItem_GetIndex(ani_field_category, &cpp_field_category_ani);
    ::ohos::book::store::Category cpp_field_category((::ohos::book::store::Category::key_t)cpp_field_category_ani);
    return ::ohos::book::store::Book{std::move(cpp_field_title), std::move(cpp_field_year), std::move(cpp_field_category)};
}
inline ani_object ohos_book_store_Book_intoANI(ani_env* env, ::ohos::book::store::Book const& cpp_obj) {
    ani_string ani_field_title;
    env->String_NewUTF8(cpp_obj.title.c_str(), cpp_obj.title.size(), &ani_field_title);
    ani_int ani_field_year = (int32_t)cpp_obj.year;
    ani_enum ani_field_category_cls;
    env->FindEnum("Lohos/book/store/Category;", &ani_field_category_cls);
ani_enum_item ani_field_category;
    env->Enum_GetEnumItemByIndex(ani_field_category_cls, (ani_size)cpp_obj.category.get_key(), &ani_field_category);
    ani_class ani_obj_cls;
    env->FindClass("Lohos/book/store/Book_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_field_title, ani_field_year, ani_field_category);
    return ani_obj;
}
