#pragma once
#include "ohos.book.store.Bookstore.proj.1.hpp"
#include "ohos.book.store.Bookstore.abi.2.h"
#include "ohos.book.store.Book.proj.1.hpp"
namespace ohos::book::store::weak {
inline void Bookstore::virtual_type::addBook(::ohos::book::store::Book const& book, double price, int32_t count) const& {
    return ohos_book_store_Bookstore_addBook_f(*reinterpret_cast<ohos_book_store_Bookstore_t const*>(this), ::taihe::into_abi<::ohos::book::store::Book const&>(book), ::taihe::into_abi<double>(price), ::taihe::into_abi<int32_t>(count));
}
}
namespace ohos::book::store::weak {
inline void Bookstore::virtual_type::saleBook(::ohos::book::store::Book const& book) const& {
    return ohos_book_store_Bookstore_saleBook_f(*reinterpret_cast<ohos_book_store_Bookstore_t const*>(this), ::taihe::into_abi<::ohos::book::store::Book const&>(book));
}
}
namespace ohos::book::store::weak {
inline double Bookstore::virtual_type::getDiscount() const& {
    return ::taihe::from_abi<double>(ohos_book_store_Bookstore_getDiscount_f(*reinterpret_cast<ohos_book_store_Bookstore_t const*>(this)));
}
}
namespace ohos::book::store::weak {
inline void Bookstore::virtual_type::setDiscount(double percent) const& {
    return ohos_book_store_Bookstore_setDiscount_f(*reinterpret_cast<ohos_book_store_Bookstore_t const*>(this), ::taihe::into_abi<double>(percent));
}
}
namespace ohos::book::store::weak {
inline double Bookstore::virtual_type::getTotalSales() const& {
    return ::taihe::from_abi<double>(ohos_book_store_Bookstore_getTotalSales_f(*reinterpret_cast<ohos_book_store_Bookstore_t const*>(this)));
}
}
namespace ohos::book::store::weak {
template<typename Impl>
void Bookstore::methods_impl<Impl>::addBook(struct ohos_book_store_Bookstore_t tobj, struct ohos_book_store_Book_t const* book, double price, int32_t count) {
    return ::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->addBook(::taihe::from_abi<::ohos::book::store::Book const&>(book), ::taihe::from_abi<double>(price), ::taihe::from_abi<int32_t>(count));
}
}
namespace ohos::book::store::weak {
template<typename Impl>
void Bookstore::methods_impl<Impl>::saleBook(struct ohos_book_store_Bookstore_t tobj, struct ohos_book_store_Book_t const* book) {
    return ::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->saleBook(::taihe::from_abi<::ohos::book::store::Book const&>(book));
}
}
namespace ohos::book::store::weak {
template<typename Impl>
double Bookstore::methods_impl<Impl>::getDiscount(struct ohos_book_store_Bookstore_t tobj) {
    return ::taihe::into_abi<double>(::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->getDiscount());
}
}
namespace ohos::book::store::weak {
template<typename Impl>
void Bookstore::methods_impl<Impl>::setDiscount(struct ohos_book_store_Bookstore_t tobj, double percent) {
    return ::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->setDiscount(::taihe::from_abi<double>(percent));
}
}
namespace ohos::book::store::weak {
template<typename Impl>
double Bookstore::methods_impl<Impl>::getTotalSales(struct ohos_book_store_Bookstore_t tobj) {
    return ::taihe::into_abi<double>(::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->getTotalSales());
}
}
