#pragma once
#include "ohos.book.store.CppBook.ani.0.h"
#include "ohos.book.store.CppBook.proj.1.hpp"
inline ::ohos::book::store::CppBook ohos_book_store_CppBook_fromANI(ani_env* env, ani_object ani_obj) {
    ani_string ani_field_title;
    env->Object_GetPropertyByName_Ref(ani_obj, "title", reinterpret_cast<ani_ref*>(&ani_field_title));

    ani_size cpp_field_title_len;
    env->String_GetUTF8Size(ani_field_title, &cpp_field_title_len);
    TString cpp_field_title_tstr;
    char* cpp_field_title_buf = tstr_initialize(&cpp_field_title_tstr, cpp_field_title_len + 1);
    env->String_GetUTF8(ani_field_title, cpp_field_title_buf, cpp_field_title_len + 1, &cpp_field_title_len);
    cpp_field_title_buf[cpp_field_title_len] = '\0';
    cpp_field_title_tstr.length = cpp_field_title_len;
    taihe::string cpp_field_title = taihe::string(cpp_field_title_tstr);
    ani_int ani_field_year;
    env->Object_GetPropertyByName_Int(ani_obj, "year", reinterpret_cast<ani_int*>(&ani_field_year));

    int32_t cpp_field_year = (int32_t)ani_field_year;
    ani_enum_item ani_field_category;
    env->Object_GetPropertyByName_Ref(ani_obj, "category", reinterpret_cast<ani_ref*>(&ani_field_category));

    ani_size cpp_field_category_ani;
    env->EnumItem_GetIndex(ani_field_category, &cpp_field_category_ani);
    ::ohos::book::store::Category cpp_field_category((::ohos::book::store::Category::key_t)cpp_field_category_ani);
    ani_string ani_field_compiler;
    env->Object_GetPropertyByName_Ref(ani_obj, "compiler", reinterpret_cast<ani_ref*>(&ani_field_compiler));

    ani_size cpp_field_compiler_len;
    env->String_GetUTF8Size(ani_field_compiler, &cpp_field_compiler_len);
    TString cpp_field_compiler_tstr;
    char* cpp_field_compiler_buf = tstr_initialize(&cpp_field_compiler_tstr, cpp_field_compiler_len + 1);
    env->String_GetUTF8(ani_field_compiler, cpp_field_compiler_buf, cpp_field_compiler_len + 1, &cpp_field_compiler_len);
    cpp_field_compiler_buf[cpp_field_compiler_len] = '\0';
    cpp_field_compiler_tstr.length = cpp_field_compiler_len;
    taihe::string cpp_field_compiler = taihe::string(cpp_field_compiler_tstr);
    return ::ohos::book::store::CppBook{std::move(cpp_field_title), std::move(cpp_field_year), std::move(cpp_field_category), std::move(cpp_field_compiler)};
}
inline ani_object ohos_book_store_CppBook_intoANI(ani_env* env, ::ohos::book::store::CppBook const& cpp_obj) {
    ani_string ani_field_title;
    env->String_NewUTF8(cpp_obj.base.title.c_str(), cpp_obj.base.title.size(), &ani_field_title);
    ani_int ani_field_year = (int32_t)cpp_obj.base.year;
    ani_enum ani_field_category_cls;
    env->FindEnum("Lohos/book/store/Category;", &ani_field_category_cls);
ani_enum_item ani_field_category;
    env->Enum_GetEnumItemByIndex(ani_field_category_cls, (ani_size)cpp_obj.base.category.get_key(), &ani_field_category);
    ani_string ani_field_compiler;
    env->String_NewUTF8(cpp_obj.compiler.c_str(), cpp_obj.compiler.size(), &ani_field_compiler);
    ani_class ani_obj_cls;
    env->FindClass("Lohos/book/store/CppBook;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_field_title, ani_field_year, ani_field_category, ani_field_compiler);
    return ani_obj;
}
