#pragma once
#include "taihe/object.hpp"
#include "ohos.book.store.FancyBook.proj.0.hpp"
#include "ohos.book.store.FancyBook.abi.1.h"
#include "ohos.book.store.HasPublisher.proj.1.hpp"
#include "ohos.book.store.HasDiscount.proj.1.hpp"
#include "ohos.book.store.HasPrice.proj.1.hpp"
#include "taihe/string.hpp"
namespace ohos::book::store::weak {
struct FancyBook {
    static constexpr bool is_holder = false;
    struct ohos_book_store_FancyBook_t m_handle;
    explicit FancyBook(struct ohos_book_store_FancyBook_t handle) : m_handle(handle) {}
    explicit FancyBook(::taihe::data_view other)
        : FancyBook(ohos_book_store_FancyBook_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::ohos::book::store::weak::HasPublisher() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasPublisher(ohos_book_store_FancyBook_1_static(ret_handle));
    }
    operator ::ohos::book::store::HasPublisher() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::ohos::book::store::HasPublisher(ohos_book_store_FancyBook_1_static(ret_handle));
    }
    operator ::ohos::book::store::weak::HasDiscount() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasDiscount(ohos_book_store_FancyBook_2_static(ret_handle));
    }
    operator ::ohos::book::store::HasDiscount() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::ohos::book::store::HasDiscount(ohos_book_store_FancyBook_2_static(ret_handle));
    }
    operator ::ohos::book::store::weak::HasPrice() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasPrice(ohos_book_store_FancyBook_3_static(ret_handle));
    }
    operator ::ohos::book::store::HasPrice() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::ohos::book::store::HasPrice(ohos_book_store_FancyBook_3_static(ret_handle));
    }
    struct virtual_type {
        ::taihe::string getTitle() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static struct TString getTitle(struct ohos_book_store_FancyBook_t tobj);
    };
    template<typename Impl>
    static constexpr ohos_book_store_FancyBook_ftable ftbl_impl = {
        .getTitle = &methods_impl<Impl>::getTitle,
    };
    template<typename Impl>
    static constexpr ohos_book_store_FancyBook_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::ohos::book::store::weak::FancyBook::template ftbl_impl<Impl>,
        .ftbl_ptr_1 = &::ohos::book::store::weak::HasPublisher::template ftbl_impl<Impl>,
        .ftbl_ptr_2 = &::ohos::book::store::weak::HasDiscount::template ftbl_impl<Impl>,
        .ftbl_ptr_3 = &::ohos::book::store::weak::HasPrice::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[4] = {
        {&ohos_book_store_FancyBook_i, &vtbl_impl<Impl>.ftbl_ptr_0},
        {&ohos_book_store_HasPublisher_i, &vtbl_impl<Impl>.ftbl_ptr_1},
        {&ohos_book_store_HasDiscount_i, &vtbl_impl<Impl>.ftbl_ptr_2},
        {&ohos_book_store_HasPrice_i, &vtbl_impl<Impl>.ftbl_ptr_3},
    };
    static constexpr void const* iid = &ohos_book_store_FancyBook_i;
    using vtable_t = ohos_book_store_FancyBook_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ohos::book::store {
struct FancyBook : public ::ohos::book::store::weak::FancyBook {
    static constexpr bool is_holder = true;
    explicit FancyBook(struct ohos_book_store_FancyBook_t handle) : ::ohos::book::store::weak::FancyBook(handle) {}
    FancyBook& operator=(::ohos::book::store::FancyBook other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~FancyBook() {
        ohos_book_store_FancyBook_drop(m_handle);
    }
    explicit FancyBook(::taihe::data_holder other)
        : FancyBook(ohos_book_store_FancyBook_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    FancyBook(::ohos::book::store::weak::FancyBook const& other)
        : FancyBook(ohos_book_store_FancyBook_copy(other.m_handle)) {}
    FancyBook(::ohos::book::store::FancyBook const& other)
        : FancyBook(ohos_book_store_FancyBook_copy(other.m_handle)) {}
    FancyBook(::ohos::book::store::FancyBook&& other)
        : FancyBook(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
    operator ::ohos::book::store::weak::HasPublisher() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasPublisher(ohos_book_store_FancyBook_1_static(ret_handle));
    }
    operator ::ohos::book::store::HasPublisher() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::ohos::book::store::HasPublisher(ohos_book_store_FancyBook_1_static(ret_handle));
    }
    operator ::ohos::book::store::HasPublisher() && {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::ohos::book::store::HasPublisher(ohos_book_store_FancyBook_1_static(ret_handle));
    }
    operator ::ohos::book::store::weak::HasDiscount() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasDiscount(ohos_book_store_FancyBook_2_static(ret_handle));
    }
    operator ::ohos::book::store::HasDiscount() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::ohos::book::store::HasDiscount(ohos_book_store_FancyBook_2_static(ret_handle));
    }
    operator ::ohos::book::store::HasDiscount() && {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::ohos::book::store::HasDiscount(ohos_book_store_FancyBook_2_static(ret_handle));
    }
    operator ::ohos::book::store::weak::HasPrice() const& {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasPrice(ohos_book_store_FancyBook_3_static(ret_handle));
    }
    operator ::ohos::book::store::HasPrice() const& {
        struct ohos_book_store_FancyBook_t ret_handle = ohos_book_store_FancyBook_copy(m_handle);
        return ::ohos::book::store::HasPrice(ohos_book_store_FancyBook_3_static(ret_handle));
    }
    operator ::ohos::book::store::HasPrice() && {
        struct ohos_book_store_FancyBook_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::ohos::book::store::HasPrice(ohos_book_store_FancyBook_3_static(ret_handle));
    }
};
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::FancyBook> {
    using type = struct ohos_book_store_FancyBook_t;
};
template<>
struct as_abi<::ohos::book::store::weak::FancyBook> {
    using type = struct ohos_book_store_FancyBook_t;
};
template<>
struct as_param<::ohos::book::store::FancyBook> {
    using type = ::ohos::book::store::weak::FancyBook;
};
}
