#pragma once
#include "taihe/object.hpp"
#include "ohos.book.store.Foo.proj.0.hpp"
#include "ohos.book.store.Foo.abi.1.h"
namespace ohos::book::store::weak {
struct Foo {
    static constexpr bool is_holder = false;
    struct ohos_book_store_Foo_t m_handle;
    explicit Foo(struct ohos_book_store_Foo_t handle) : m_handle(handle) {}
    explicit Foo(::taihe::data_view other)
        : Foo(ohos_book_store_Foo_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ohos_book_store_Foo_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_Foo_t ret_handle = ohos_book_store_Foo_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
    };
    template<typename Impl>
    struct methods_impl {
    };
    template<typename Impl>
    static constexpr ohos_book_store_Foo_ftable ftbl_impl = {
    };
    template<typename Impl>
    static constexpr ohos_book_store_Foo_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::ohos::book::store::weak::Foo::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&ohos_book_store_Foo_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &ohos_book_store_Foo_i;
    using vtable_t = ohos_book_store_Foo_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ohos::book::store {
struct Foo : public ::ohos::book::store::weak::Foo {
    static constexpr bool is_holder = true;
    explicit Foo(struct ohos_book_store_Foo_t handle) : ::ohos::book::store::weak::Foo(handle) {}
    Foo& operator=(::ohos::book::store::Foo other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~Foo() {
        ohos_book_store_Foo_drop(m_handle);
    }
    explicit Foo(::taihe::data_holder other)
        : Foo(ohos_book_store_Foo_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ohos_book_store_Foo_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_Foo_t ret_handle = ohos_book_store_Foo_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ohos_book_store_Foo_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    Foo(::ohos::book::store::weak::Foo const& other)
        : Foo(ohos_book_store_Foo_copy(other.m_handle)) {}
    Foo(::ohos::book::store::Foo const& other)
        : Foo(ohos_book_store_Foo_copy(other.m_handle)) {}
    Foo(::ohos::book::store::Foo&& other)
        : Foo(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::Foo> {
    using type = struct ohos_book_store_Foo_t;
};
template<>
struct as_abi<::ohos::book::store::weak::Foo> {
    using type = struct ohos_book_store_Foo_t;
};
template<>
struct as_param<::ohos::book::store::Foo> {
    using type = ::ohos::book::store::weak::Foo;
};
}
