#pragma once
#include "ohos.book.store.HasPrice.ani.0.h"
#include "ohos.book.store.HasPrice.proj.2.hpp"
inline ::ohos::book::store::HasPrice ohos_book_store_HasPrice_fromANI(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        double getPrice() {
            ani_double ani_result;
            this->env->Object_CallMethodByName_Double(this->ref, "<get>price", nullptr, reinterpret_cast<ani_double*>(&ani_result));

        double cpp_result = (double)ani_result;
            return cpp_result;
        }
    };
    return taihe::make_holder<cpp_impl_t, ::ohos::book::store::HasPrice>(env, ani_obj);
}
inline ani_object ohos_book_store_HasPrice_intoANI(ani_env* env, ::ohos::book::store::HasPrice cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Lohos/book/store/HasPrice_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
