#pragma once
#include "taihe/object.hpp"
#include "ohos.book.store.HasPrice.proj.0.hpp"
#include "ohos.book.store.HasPrice.abi.1.h"
namespace ohos::book::store::weak {
struct HasPrice {
    static constexpr bool is_holder = false;
    struct ohos_book_store_HasPrice_t m_handle;
    explicit HasPrice(struct ohos_book_store_HasPrice_t handle) : m_handle(handle) {}
    explicit HasPrice(::taihe::data_view other)
        : HasPrice(ohos_book_store_HasPrice_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ohos_book_store_HasPrice_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_HasPrice_t ret_handle = ohos_book_store_HasPrice_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        double getPrice() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static double getPrice(struct ohos_book_store_HasPrice_t tobj);
    };
    template<typename Impl>
    static constexpr ohos_book_store_HasPrice_ftable ftbl_impl = {
        .getPrice = &methods_impl<Impl>::getPrice,
    };
    template<typename Impl>
    static constexpr ohos_book_store_HasPrice_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::ohos::book::store::weak::HasPrice::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&ohos_book_store_HasPrice_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &ohos_book_store_HasPrice_i;
    using vtable_t = ohos_book_store_HasPrice_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ohos::book::store {
struct HasPrice : public ::ohos::book::store::weak::HasPrice {
    static constexpr bool is_holder = true;
    explicit HasPrice(struct ohos_book_store_HasPrice_t handle) : ::ohos::book::store::weak::HasPrice(handle) {}
    HasPrice& operator=(::ohos::book::store::HasPrice other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~HasPrice() {
        ohos_book_store_HasPrice_drop(m_handle);
    }
    explicit HasPrice(::taihe::data_holder other)
        : HasPrice(ohos_book_store_HasPrice_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ohos_book_store_HasPrice_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_HasPrice_t ret_handle = ohos_book_store_HasPrice_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ohos_book_store_HasPrice_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    HasPrice(::ohos::book::store::weak::HasPrice const& other)
        : HasPrice(ohos_book_store_HasPrice_copy(other.m_handle)) {}
    HasPrice(::ohos::book::store::HasPrice const& other)
        : HasPrice(ohos_book_store_HasPrice_copy(other.m_handle)) {}
    HasPrice(::ohos::book::store::HasPrice&& other)
        : HasPrice(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::HasPrice> {
    using type = struct ohos_book_store_HasPrice_t;
};
template<>
struct as_abi<::ohos::book::store::weak::HasPrice> {
    using type = struct ohos_book_store_HasPrice_t;
};
template<>
struct as_param<::ohos::book::store::HasPrice> {
    using type = ::ohos::book::store::weak::HasPrice;
};
}
