#pragma once
#include "taihe/object.hpp"
#include "ohos.book.store.Path.proj.0.hpp"
#include "ohos.book.store.Path.abi.1.h"
namespace ohos::book::store::weak {
struct Path {
    static constexpr bool is_holder = false;
    struct ohos_book_store_Path_t m_handle;
    explicit Path(struct ohos_book_store_Path_t handle) : m_handle(handle) {}
    explicit Path(::taihe::data_view other)
        : Path(ohos_book_store_Path_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ohos_book_store_Path_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_Path_t ret_handle = ohos_book_store_Path_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
    };
    template<typename Impl>
    struct methods_impl {
    };
    template<typename Impl>
    static constexpr ohos_book_store_Path_ftable ftbl_impl = {
    };
    template<typename Impl>
    static constexpr ohos_book_store_Path_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::ohos::book::store::weak::Path::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&ohos_book_store_Path_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &ohos_book_store_Path_i;
    using vtable_t = ohos_book_store_Path_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ohos::book::store {
struct Path : public ::ohos::book::store::weak::Path {
    static constexpr bool is_holder = true;
    explicit Path(struct ohos_book_store_Path_t handle) : ::ohos::book::store::weak::Path(handle) {}
    Path& operator=(::ohos::book::store::Path other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~Path() {
        ohos_book_store_Path_drop(m_handle);
    }
    explicit Path(::taihe::data_holder other)
        : Path(ohos_book_store_Path_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ohos_book_store_Path_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_Path_t ret_handle = ohos_book_store_Path_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ohos_book_store_Path_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    Path(::ohos::book::store::weak::Path const& other)
        : Path(ohos_book_store_Path_copy(other.m_handle)) {}
    Path(::ohos::book::store::Path const& other)
        : Path(ohos_book_store_Path_copy(other.m_handle)) {}
    Path(::ohos::book::store::Path&& other)
        : Path(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::Path> {
    using type = struct ohos_book_store_Path_t;
};
template<>
struct as_abi<::ohos::book::store::weak::Path> {
    using type = struct ohos_book_store_Path_t;
};
template<>
struct as_param<::ohos::book::store::Path> {
    using type = ::ohos::book::store::weak::Path;
};
}
