#pragma once
#include "taihe/common.hpp"
#include "ohos.book.store.RustBook.proj.0.hpp"
#include "ohos.book.store.RustBook.abi.1.h"
#include "ohos.book.store.Book.proj.1.hpp"
namespace ohos::book::store {
struct RustBook {
    ::ohos::book::store::Book base;
    int32_t rust_version;
};
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::ohos::book::store::RustBook const& val) -> ::std::size_t {
    ::std::size_t seed = 0;
    seed ^= hash(val.base) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.rust_version) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    return seed;
}
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::ohos::book::store::RustBook const& lhs, ::ohos::book::store::RustBook const& rhs) {
    return true && same(lhs.base, rhs.base) && same(lhs.rust_version, rhs.rust_version);
}
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::RustBook> {
    using type = struct ohos_book_store_RustBook_t;
};
template<>
struct as_abi<::ohos::book::store::RustBook const&> {
    using type = struct ohos_book_store_RustBook_t const*;
};
template<>
struct as_param<::ohos::book::store::RustBook> {
    using type = ::ohos::book::store::RustBook const&;
};
}
