#include "external_obj.proj.hpp"
#include "external_obj.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace external_obj;

namespace {
// To be implemented.

bool is_string(uintptr_t s) {
    TH_THROW(std::runtime_error, "is_string not implemented");
}

array<uintptr_t> get_objects() {
    TH_THROW(std::runtime_error, "get_objects not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_is_string(is_string);
TH_EXPORT_CPP_API_get_objects(get_objects);
