#pragma once
#include "inherit.CreditCard.ani.0.h"
#include "inherit.CreditCard.proj.2.hpp"
inline ::inherit::CreditCard inherit_CreditCard_fromANI(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        void topUp(double cpp_arg_topUpAmount) {
        ani_double ani_arg_topUpAmount = (double)cpp_arg_topUpAmount;
            this->env->Object_CallMethodByName_Void(this->ref, "topUp", nullptr, ani_arg_topUpAmount);

        }
        double getBalance() {
            ani_double ani_result;
            this->env->Object_CallMethodByName_Double(this->ref, "<get>balance", nullptr, reinterpret_cast<ani_double*>(&ani_result));

        double cpp_result = (double)ani_result;
            return cpp_result;
        }
        bool getIntlEnabled() {
            ani_boolean ani_result;
            this->env->Object_CallMethodByName_Boolean(this->ref, "<get>intlEnabled", nullptr, reinterpret_cast<ani_boolean*>(&ani_result));

        bool cpp_result = (bool)ani_result;
            return cpp_result;
        }
        void setIntlEnabled(bool cpp_arg_tag) {
        ani_boolean ani_arg_tag = (bool)cpp_arg_tag;
            this->env->Object_CallMethodByName_Void(this->ref, "<set>intlEnabled", nullptr, ani_arg_tag);

        }
        void pay(double cpp_arg_amountDue) {
        ani_double ani_arg_amountDue = (double)cpp_arg_amountDue;
            this->env->Object_CallMethodByName_Void(this->ref, "pay", nullptr, ani_arg_amountDue);

        }
    };
    return taihe::make_holder<cpp_impl_t, ::inherit::CreditCard>(env, ani_obj);
}
inline ani_object inherit_CreditCard_intoANI(ani_env* env, ::inherit::CreditCard cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Linherit/CreditCard;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
