#pragma once
#include "inherit.Payable.ani.0.h"
#include "inherit.Payable.proj.2.hpp"
inline ::inherit::Payable inherit_Payable_fromANI(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        void pay(double cpp_arg_amountDue) {
        ani_double ani_arg_amountDue = (double)cpp_arg_amountDue;
            this->env->Object_CallMethodByName_Void(this->ref, "pay", nullptr, ani_arg_amountDue);

        }
    };
    return taihe::make_holder<cpp_impl_t, ::inherit::Payable>(env, ani_obj);
}
inline ani_object inherit_Payable_intoANI(ani_env* env, ::inherit::Payable cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Linherit/Payable_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
