#pragma once
#include "taihe/object.hpp"
#include "inherit.Payable.proj.0.hpp"
#include "inherit.Payable.abi.1.h"
namespace inherit::weak {
struct Payable {
    static constexpr bool is_holder = false;
    struct inherit_Payable_t m_handle;
    explicit Payable(struct inherit_Payable_t handle) : m_handle(handle) {}
    explicit Payable(::taihe::data_view other)
        : Payable(inherit_Payable_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct inherit_Payable_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct inherit_Payable_t ret_handle = inherit_Payable_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        void pay(double amountDue) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void pay(struct inherit_Payable_t tobj, double amountDue);
    };
    template<typename Impl>
    static constexpr inherit_Payable_ftable ftbl_impl = {
        .pay = &methods_impl<Impl>::pay,
    };
    template<typename Impl>
    static constexpr inherit_Payable_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::inherit::weak::Payable::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&inherit_Payable_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &inherit_Payable_i;
    using vtable_t = inherit_Payable_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace inherit {
struct Payable : public ::inherit::weak::Payable {
    static constexpr bool is_holder = true;
    explicit Payable(struct inherit_Payable_t handle) : ::inherit::weak::Payable(handle) {}
    Payable& operator=(::inherit::Payable other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~Payable() {
        inherit_Payable_drop(m_handle);
    }
    explicit Payable(::taihe::data_holder other)
        : Payable(inherit_Payable_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct inherit_Payable_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct inherit_Payable_t ret_handle = inherit_Payable_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct inherit_Payable_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    Payable(::inherit::weak::Payable const& other)
        : Payable(inherit_Payable_copy(other.m_handle)) {}
    Payable(::inherit::Payable const& other)
        : Payable(inherit_Payable_copy(other.m_handle)) {}
    Payable(::inherit::Payable&& other)
        : Payable(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::inherit::Payable> {
    using type = struct inherit_Payable_t;
};
template<>
struct as_abi<::inherit::weak::Payable> {
    using type = struct inherit_Payable_t;
};
template<>
struct as_param<::inherit::Payable> {
    using type = ::inherit::weak::Payable;
};
}
