#include "inherit.ani.hpp"
#include "inherit.user.hpp"
#include "inherit.CreditCard.ani.1.h"
static ani_object inherit_makeCreditCard_ANIFunc([[maybe_unused]] ani_env *env, ani_double ani_arg_initAmount) {
    ::taihe::set_env(env);
    double cpp_arg_initAmount = (double)ani_arg_initAmount;
    ::inherit::CreditCard cpp_result = ::inherit::makeCreditCard(cpp_arg_initAmount);
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = inherit_CreditCard_intoANI(env, cpp_result);
    return ani_result;
}
static void inherit_Payable_pay_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_double ani_arg_amountDue) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    inherit_Payable_vtable* cpp_vtbl_ptr = reinterpret_cast<inherit_Payable_vtable*>(ani_vtbl_ptr);
    ::inherit::weak::Payable cpp_iface = ::inherit::weak::Payable({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_arg_amountDue = (double)ani_arg_amountDue;
    ::inherit::weak::Payable(cpp_iface)->pay(cpp_arg_amountDue);
}
static void inherit_CreditCard_topUp_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_double ani_arg_topUpAmount) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    inherit_CreditCard_vtable* cpp_vtbl_ptr = reinterpret_cast<inherit_CreditCard_vtable*>(ani_vtbl_ptr);
    ::inherit::weak::CreditCard cpp_iface = ::inherit::weak::CreditCard({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_arg_topUpAmount = (double)ani_arg_topUpAmount;
    ::inherit::weak::CreditCard(cpp_iface)->topUp(cpp_arg_topUpAmount);
}
static ani_double inherit_CreditCard_getBalance_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    inherit_CreditCard_vtable* cpp_vtbl_ptr = reinterpret_cast<inherit_CreditCard_vtable*>(ani_vtbl_ptr);
    ::inherit::weak::CreditCard cpp_iface = ::inherit::weak::CreditCard({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_result = ::inherit::weak::CreditCard(cpp_iface)->getBalance();
    if (::taihe::has_error()) { return ani_double{}; }
    ani_double ani_result = (double)cpp_result;
    return ani_result;
}
static ani_boolean inherit_CreditCard_getIntlEnabled_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    inherit_CreditCard_vtable* cpp_vtbl_ptr = reinterpret_cast<inherit_CreditCard_vtable*>(ani_vtbl_ptr);
    ::inherit::weak::CreditCard cpp_iface = ::inherit::weak::CreditCard({cpp_vtbl_ptr, cpp_data_ptr});
    bool cpp_result = ::inherit::weak::CreditCard(cpp_iface)->getIntlEnabled();
    if (::taihe::has_error()) { return ani_boolean{}; }
    ani_boolean ani_result = (bool)cpp_result;
    return ani_result;
}
static void inherit_CreditCard_setIntlEnabled_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_boolean ani_arg_tag) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    inherit_CreditCard_vtable* cpp_vtbl_ptr = reinterpret_cast<inherit_CreditCard_vtable*>(ani_vtbl_ptr);
    ::inherit::weak::CreditCard cpp_iface = ::inherit::weak::CreditCard({cpp_vtbl_ptr, cpp_data_ptr});
    bool cpp_arg_tag = (bool)ani_arg_tag;
    ::inherit::weak::CreditCard(cpp_iface)->setIntlEnabled(cpp_arg_tag);
}
static void inherit_CreditCard_pay_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_double ani_arg_amountDue) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    inherit_CreditCard_vtable* cpp_vtbl_ptr = reinterpret_cast<inherit_CreditCard_vtable*>(ani_vtbl_ptr);
    ::inherit::weak::CreditCard cpp_iface = ::inherit::weak::CreditCard({cpp_vtbl_ptr, cpp_data_ptr});
    double cpp_arg_amountDue = (double)ani_arg_amountDue;
    ::inherit::weak::Payable(cpp_iface)->pay(cpp_arg_amountDue);
}
namespace inherit {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Linherit;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"makeCreditCard_inner", nullptr, reinterpret_cast<void*>(inherit_makeCreditCard_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Linherit/Payable_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"pay_inner", nullptr, reinterpret_cast<void*>(inherit_Payable_pay_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Linherit/CreditCard;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"topUp_inner", nullptr, reinterpret_cast<void*>(inherit_CreditCard_topUp_ANIFunc)},

            {"getBalance_inner", nullptr, reinterpret_cast<void*>(inherit_CreditCard_getBalance_ANIFunc)},

            {"getIntlEnabled_inner", nullptr, reinterpret_cast<void*>(inherit_CreditCard_getIntlEnabled_ANIFunc)},

            {"setIntlEnabled_inner", nullptr, reinterpret_cast<void*>(inherit_CreditCard_setIntlEnabled_ANIFunc)},

            {"pay_inner", nullptr, reinterpret_cast<void*>(inherit_CreditCard_pay_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
