#pragma once
#include "taihe/object.hpp"
#include "class_extends.BaseContext.proj.0.hpp"
#include "class_extends.BaseContext.abi.1.h"
#include "taihe/string.hpp"
namespace class_extends::weak {
struct BaseContext {
    static constexpr bool is_holder = false;
    struct class_extends_BaseContext_t0 m_handle;
    explicit BaseContext(struct class_extends_BaseContext_t0 handle) : m_handle(handle) {}
    explicit BaseContext(::taihe::data_view other)
        : BaseContext(class_extends_BaseContext_dynamic0(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct class_extends_BaseContext_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct class_extends_BaseContext_t0 ret_handle = class_extends_BaseContext_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        void setName(::taihe::string_view name) const&;
        ::taihe::string getName() const&;
        ::taihe::string getType(::taihe::string_view ctxType) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void setName(struct class_extends_BaseContext_t0 tobj, struct TString name);
        static struct TString getName(struct class_extends_BaseContext_t0 tobj);
        static struct TString getType(struct class_extends_BaseContext_t0 tobj, struct TString ctxType);
    };
    template<typename Impl>
    static constexpr class_extends_BaseContext_ftable0 ftbl_impl = {
        .setName = &methods_impl<Impl>::setName,
        .getName = &methods_impl<Impl>::getName,
        .getType = &methods_impl<Impl>::getType,
    };
    template<typename Impl>
    static constexpr class_extends_BaseContext_vtable0 vtbl_impl = {
        .ftbl_ptr_0 = &::class_extends::weak::BaseContext::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&class_extends_BaseContext_i0, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &class_extends_BaseContext_i0;
    using vtable_t = class_extends_BaseContext_vtable0;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace class_extends {
struct BaseContext : public ::class_extends::weak::BaseContext {
    static constexpr bool is_holder = true;
    explicit BaseContext(struct class_extends_BaseContext_t0 handle) : ::class_extends::weak::BaseContext(handle) {}
    BaseContext& operator=(::class_extends::BaseContext other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~BaseContext() {
        class_extends_BaseContext_drop0(m_handle);
    }
    explicit BaseContext(::taihe::data_holder other)
        : BaseContext(class_extends_BaseContext_dynamic0(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct class_extends_BaseContext_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct class_extends_BaseContext_t0 ret_handle = class_extends_BaseContext_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct class_extends_BaseContext_t0 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    BaseContext(::class_extends::weak::BaseContext const& other)
        : BaseContext(class_extends_BaseContext_copy0(other.m_handle)) {}
    BaseContext(::class_extends::BaseContext const& other)
        : BaseContext(class_extends_BaseContext_copy0(other.m_handle)) {}
    BaseContext(::class_extends::BaseContext&& other)
        : BaseContext(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::class_extends::BaseContext> {
    using type = struct class_extends_BaseContext_t0;
};
template<>
struct as_abi<::class_extends::weak::BaseContext> {
    using type = struct class_extends_BaseContext_t0;
};
template<>
struct as_param<::class_extends::BaseContext> {
    using type = ::class_extends::weak::BaseContext;
};
}
