#pragma once
#include "class_extends.Context.ani.0.h"
#include "class_extends.Context.proj.2.hpp"
inline ::class_extends::Context class_extends_Context_fromANI0(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        void setStageMode(bool cpp_arg_stageMode) {
        ani_boolean ani_arg_stageMode = (bool)cpp_arg_stageMode;
            this->env->Object_CallMethodByName_Void(this->ref, "<set>stageMode", nullptr, ani_arg_stageMode);

        }
        bool getStageMode() {
            ani_boolean ani_result;
            this->env->Object_CallMethodByName_Boolean(this->ref, "<get>stageMode", nullptr, reinterpret_cast<ani_boolean*>(&ani_result));

        bool cpp_result = (bool)ani_result;
            return cpp_result;
        }
        void setName(::taihe::string_view cpp_arg_name) {
        ani_string ani_arg_name;
        this->env->String_NewUTF8(cpp_arg_name.c_str(), cpp_arg_name.size(), &ani_arg_name);
            this->env->Object_CallMethodByName_Void(this->ref, "<set>name", nullptr, ani_arg_name);

        }
        ::taihe::string getName() {
            ani_string ani_result;
            this->env->Object_CallMethodByName_Ref(this->ref, "<get>name", nullptr, reinterpret_cast<ani_ref*>(&ani_result));

        ani_size cpp_result_len;
        this->env->String_GetUTF8Size(ani_result, &cpp_result_len);
        TString cpp_result_tstr;
        char* cpp_result_buf = tstr_initialize(&cpp_result_tstr, cpp_result_len + 1);
        this->env->String_GetUTF8(ani_result, cpp_result_buf, cpp_result_len + 1, &cpp_result_len);
        cpp_result_buf[cpp_result_len] = '\0';
        cpp_result_tstr.length = cpp_result_len;
        taihe::string cpp_result = taihe::string(cpp_result_tstr);
            return cpp_result;
        }
        ::taihe::string getType(::taihe::string_view cpp_arg_ctxType) {
        ani_string ani_arg_ctxType;
        this->env->String_NewUTF8(cpp_arg_ctxType.c_str(), cpp_arg_ctxType.size(), &ani_arg_ctxType);
            ani_string ani_result;
            this->env->Object_CallMethodByName_Ref(this->ref, "getType", nullptr, reinterpret_cast<ani_ref*>(&ani_result), ani_arg_ctxType);

        ani_size cpp_result_len;
        this->env->String_GetUTF8Size(ani_result, &cpp_result_len);
        TString cpp_result_tstr;
        char* cpp_result_buf = tstr_initialize(&cpp_result_tstr, cpp_result_len + 1);
        this->env->String_GetUTF8(ani_result, cpp_result_buf, cpp_result_len + 1, &cpp_result_len);
        cpp_result_buf[cpp_result_len] = '\0';
        cpp_result_tstr.length = cpp_result_len;
        taihe::string cpp_result = taihe::string(cpp_result_tstr);
            return cpp_result;
        }
    };
    return taihe::make_holder<cpp_impl_t, ::class_extends::Context>(env, ani_obj);
}
inline ani_object class_extends_Context_intoANI0(ani_env* env, ::class_extends::Context cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Lclass_extends/Context_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
