#pragma once
#include "taihe/object.hpp"
#include "class_extends.TestContext.proj.0.hpp"
#include "class_extends.TestContext.abi.1.h"
#include "class_extends.BaseContext.proj.1.hpp"
namespace class_extends::weak {
struct TestContext {
    static constexpr bool is_holder = false;
    struct class_extends_TestContext_t0 m_handle;
    explicit TestContext(struct class_extends_TestContext_t0 handle) : m_handle(handle) {}
    explicit TestContext(::taihe::data_view other)
        : TestContext(class_extends_TestContext_dynamic0(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct class_extends_TestContext_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct class_extends_TestContext_t0 ret_handle = class_extends_TestContext_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::class_extends::weak::BaseContext() const& {
        struct class_extends_TestContext_t0 ret_handle = m_handle;
        return ::class_extends::weak::BaseContext(class_extends_TestContext_1_static0(ret_handle));
    }
    operator ::class_extends::BaseContext() const& {
        struct class_extends_TestContext_t0 ret_handle = class_extends_TestContext_copy0(m_handle);
        return ::class_extends::BaseContext(class_extends_TestContext_1_static0(ret_handle));
    }
    struct virtual_type {
    };
    template<typename Impl>
    struct methods_impl {
    };
    template<typename Impl>
    static constexpr class_extends_TestContext_ftable0 ftbl_impl = {
    };
    template<typename Impl>
    static constexpr class_extends_TestContext_vtable0 vtbl_impl = {
        .ftbl_ptr_0 = &::class_extends::weak::TestContext::template ftbl_impl<Impl>,
        .ftbl_ptr_1 = &::class_extends::weak::BaseContext::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[2] = {
        {&class_extends_TestContext_i0, &vtbl_impl<Impl>.ftbl_ptr_0},
        {&class_extends_BaseContext_i0, &vtbl_impl<Impl>.ftbl_ptr_1},
    };
    static constexpr void const* iid = &class_extends_TestContext_i0;
    using vtable_t = class_extends_TestContext_vtable0;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace class_extends {
struct TestContext : public ::class_extends::weak::TestContext {
    static constexpr bool is_holder = true;
    explicit TestContext(struct class_extends_TestContext_t0 handle) : ::class_extends::weak::TestContext(handle) {}
    TestContext& operator=(::class_extends::TestContext other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~TestContext() {
        class_extends_TestContext_drop0(m_handle);
    }
    explicit TestContext(::taihe::data_holder other)
        : TestContext(class_extends_TestContext_dynamic0(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct class_extends_TestContext_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct class_extends_TestContext_t0 ret_handle = class_extends_TestContext_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct class_extends_TestContext_t0 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    TestContext(::class_extends::weak::TestContext const& other)
        : TestContext(class_extends_TestContext_copy0(other.m_handle)) {}
    TestContext(::class_extends::TestContext const& other)
        : TestContext(class_extends_TestContext_copy0(other.m_handle)) {}
    TestContext(::class_extends::TestContext&& other)
        : TestContext(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
    operator ::class_extends::weak::BaseContext() const& {
        struct class_extends_TestContext_t0 ret_handle = m_handle;
        return ::class_extends::weak::BaseContext(class_extends_TestContext_1_static0(ret_handle));
    }
    operator ::class_extends::BaseContext() const& {
        struct class_extends_TestContext_t0 ret_handle = class_extends_TestContext_copy0(m_handle);
        return ::class_extends::BaseContext(class_extends_TestContext_1_static0(ret_handle));
    }
    operator ::class_extends::BaseContext() && {
        struct class_extends_TestContext_t0 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::class_extends::BaseContext(class_extends_TestContext_1_static0(ret_handle));
    }
};
}
namespace taihe {
template<>
struct as_abi<::class_extends::TestContext> {
    using type = struct class_extends_TestContext_t0;
};
template<>
struct as_abi<::class_extends::weak::TestContext> {
    using type = struct class_extends_TestContext_t0;
};
template<>
struct as_param<::class_extends::TestContext> {
    using type = ::class_extends::weak::TestContext;
};
}
