#include "class_extends.ani.hpp"
#include "extends_inject.ani.hpp"
ANI_EXPORT ani_status ANI_Constructor(ani_vm *vm, uint32_t *result) {
    ani_env *env;
    if (ANI_OK != vm->GetEnv(ANI_VERSION_1, &env)) {
        return ANI_ERROR;
    }
    if (ANI_OK != class_extends::ANIRegister(env)) {
        std::cerr << "class_extends" << std::endl;
        return ANI_ERROR;
    }
    if (ANI_OK != extends_inject::ANIRegister(env)) {
        std::cerr << "extends_inject" << std::endl;
        return ANI_ERROR;
    }
    *result = ANI_VERSION_1;
    return ANI_OK;
}
