#pragma once
#include "taihe/object.abi.h"
#include "interface.ICalculator.abi.0.h"
TH_EXPORT void const* const interface_ICalculator_i;
struct interface_ICalculator_ftable {
    int32_t (*add)(struct interface_ICalculator_t tobj, int32_t a, int32_t b);
    int32_t (*sub)(struct interface_ICalculator_t tobj, int32_t a, int32_t b);
    int32_t (*getLastResult)(struct interface_ICalculator_t tobj);
    void (*reset)(struct interface_ICalculator_t tobj);
};
struct interface_ICalculator_vtable {
    struct interface_ICalculator_ftable const* ftbl_ptr_0;
};
struct interface_ICalculator_t {
    struct interface_ICalculator_vtable const* vtbl_ptr;
    struct DataBlockHead* data_ptr;
};
TH_INLINE struct interface_ICalculator_t interface_ICalculator_dynamic(struct DataBlockHead* data_ptr) {
    struct TypeInfo const* rtti_ptr = data_ptr->rtti_ptr;
    struct interface_ICalculator_t result;
    result.data_ptr = data_ptr;    for (size_t i = 0; i < rtti_ptr->len; i++) {
        if (rtti_ptr->idmap[i].id == interface_ICalculator_i) {
            result.vtbl_ptr = (struct interface_ICalculator_vtable*)rtti_ptr->idmap[i].vtbl_ptr;
            return result;
        }
    }
    result.vtbl_ptr = NULL;
    return result;
}
TH_INLINE struct interface_ICalculator_t interface_ICalculator_copy(struct interface_ICalculator_t tobj) {
    struct DataBlockHead* data_ptr = tobj.data_ptr;
    if (data_ptr) {
        tref_inc(&data_ptr->m_count);
    }
    return tobj;
}
TH_INLINE void interface_ICalculator_drop(struct interface_ICalculator_t tobj) {
    struct DataBlockHead* data_ptr = tobj.data_ptr;
    if (data_ptr && tref_dec(&data_ptr->m_count)) {
        data_ptr->rtti_ptr->free(data_ptr);
    }
}
