#include "interface.ani.hpp"
#include "interface.user.hpp"
#include "interface.ICalculator.ani.1.h"
static ani_object interface_makeCalculator_ANIFunc([[maybe_unused]] ani_env *env, ani_int ani_arg_init) {
    ::taihe::set_env(env);
    int32_t cpp_arg_init = (int32_t)ani_arg_init;
    ::interface::ICalculator cpp_result = ::interface::makeCalculator(cpp_arg_init);
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = interface_ICalculator_intoANI(env, cpp_result);
    return ani_result;
}
static void interface_restartCalculator_ANIFunc([[maybe_unused]] ani_env *env, ani_object ani_arg_a) {
    ::taihe::set_env(env);
    ::interface::ICalculator cpp_arg_a = interface_ICalculator_fromANI(env, ani_arg_a);
    ::interface::restartCalculator(cpp_arg_a);
}
static ani_int interface_ICalculator_add_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_int ani_arg_a, ani_int ani_arg_b) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    interface_ICalculator_vtable* cpp_vtbl_ptr = reinterpret_cast<interface_ICalculator_vtable*>(ani_vtbl_ptr);
    ::interface::weak::ICalculator cpp_iface = ::interface::weak::ICalculator({cpp_vtbl_ptr, cpp_data_ptr});
    int32_t cpp_arg_a = (int32_t)ani_arg_a;
    int32_t cpp_arg_b = (int32_t)ani_arg_b;
    int32_t cpp_result = ::interface::weak::ICalculator(cpp_iface)->add(cpp_arg_a, cpp_arg_b);
    if (::taihe::has_error()) { return ani_int{}; }
    ani_int ani_result = (int32_t)cpp_result;
    return ani_result;
}
static ani_int interface_ICalculator_sub_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_int ani_arg_a, ani_int ani_arg_b) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    interface_ICalculator_vtable* cpp_vtbl_ptr = reinterpret_cast<interface_ICalculator_vtable*>(ani_vtbl_ptr);
    ::interface::weak::ICalculator cpp_iface = ::interface::weak::ICalculator({cpp_vtbl_ptr, cpp_data_ptr});
    int32_t cpp_arg_a = (int32_t)ani_arg_a;
    int32_t cpp_arg_b = (int32_t)ani_arg_b;
    int32_t cpp_result = ::interface::weak::ICalculator(cpp_iface)->sub(cpp_arg_a, cpp_arg_b);
    if (::taihe::has_error()) { return ani_int{}; }
    ani_int ani_result = (int32_t)cpp_result;
    return ani_result;
}
static ani_int interface_ICalculator_getLastResult_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    interface_ICalculator_vtable* cpp_vtbl_ptr = reinterpret_cast<interface_ICalculator_vtable*>(ani_vtbl_ptr);
    ::interface::weak::ICalculator cpp_iface = ::interface::weak::ICalculator({cpp_vtbl_ptr, cpp_data_ptr});
    int32_t cpp_result = ::interface::weak::ICalculator(cpp_iface)->getLastResult();
    if (::taihe::has_error()) { return ani_int{}; }
    ani_int ani_result = (int32_t)cpp_result;
    return ani_result;
}
static void interface_ICalculator_reset_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    interface_ICalculator_vtable* cpp_vtbl_ptr = reinterpret_cast<interface_ICalculator_vtable*>(ani_vtbl_ptr);
    ::interface::weak::ICalculator cpp_iface = ::interface::weak::ICalculator({cpp_vtbl_ptr, cpp_data_ptr});
    ::interface::weak::ICalculator(cpp_iface)->reset();
}
namespace interface {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Linterface;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"makeCalculator_inner", nullptr, reinterpret_cast<void*>(interface_makeCalculator_ANIFunc)},

            {"restartCalculator_inner", nullptr, reinterpret_cast<void*>(interface_restartCalculator_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Linterface/ICalculator_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"add_inner", nullptr, reinterpret_cast<void*>(interface_ICalculator_add_ANIFunc)},

            {"sub_inner", nullptr, reinterpret_cast<void*>(interface_ICalculator_sub_ANIFunc)},

            {"getLastResult_inner", nullptr, reinterpret_cast<void*>(interface_ICalculator_getLastResult_ANIFunc)},

            {"reset_inner", nullptr, reinterpret_cast<void*>(interface_ICalculator_reset_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
