#pragma once
#include "taihe/common.hpp"
#include "ns_test.baz.Data.proj.0.hpp"
#include "ns_test.baz.Data.abi.1.h"
#include "taihe/string.hpp"
namespace ns_test::baz {
struct Data {
    ::taihe::string a;
    ::taihe::string b;
    int32_t c;
};
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::ns_test::baz::Data const& val) -> ::std::size_t {
    ::std::size_t seed = 0;
    seed ^= hash(val.a) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.b) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.c) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    return seed;
}
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::ns_test::baz::Data const& lhs, ::ns_test::baz::Data const& rhs) {
    return true && same(lhs.a, rhs.a) && same(lhs.b, rhs.b) && same(lhs.c, rhs.c);
}
}
namespace taihe {
template<>
struct as_abi<::ns_test::baz::Data> {
    using type = struct ns_test_baz_Data_t0;
};
template<>
struct as_abi<::ns_test::baz::Data const&> {
    using type = struct ns_test_baz_Data_t0 const*;
};
template<>
struct as_param<::ns_test::baz::Data> {
    using type = ::ns_test::baz::Data const&;
};
}
