#pragma once
#include "ns_test.foo.window.ani.0.h"
#include "ns_test.foo.window.proj.2.hpp"
inline ::ns_test::foo::window ns_test_foo_window_fromANI0(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        int32_t getheight() {
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "getheight", nullptr, reinterpret_cast<ani_int*>(&ani_result));

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        void setheight(int32_t cpp_arg_b) {
        ani_int ani_arg_b = (int32_t)cpp_arg_b;
            this->env->Object_CallMethodByName_Void(this->ref, "setheight", nullptr, ani_arg_b);

        }
    };
    return taihe::make_holder<cpp_impl_t, ::ns_test::foo::window>(env, ani_obj);
}
inline ani_object ns_test_foo_window_intoANI0(ani_env* env, ::ns_test::foo::window cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Lns_test/foo/window_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
