#include "ns_test.baz.proj.hpp"
#include "ns_test.baz.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace ns_test::baz;

namespace {
// To be implemented.

string concatStruct(Data const& data) {
    TH_THROW(std::runtime_error, "concatStruct not implemented");
}

Data makeStruct(string_view a, string_view b, int32_t c) {
    TH_THROW(std::runtime_error, "makeStruct not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_concatStruct(concatStruct);
TH_EXPORT_CPP_API_makeStruct(makeStruct);
