#include "overload.proj.hpp"
#include "overload.impl.hpp"
#include "taihe/runtime.hpp"
#include "stdexcept"

using namespace taihe;
using namespace overload;

namespace {
// To be implemented.

int32_t sum_two(int32_t a, int32_t b) {
    TH_THROW(std::runtime_error, "sum_two not implemented");
}

int32_t sum_arr(array_view<int32_t> a) {
    TH_THROW(std::runtime_error, "sum_arr not implemented");
}
}  // namespace

TH_EXPORT_CPP_API_sum_two(sum_two);
TH_EXPORT_CPP_API_sum_arr(sum_arr);
