#include "override.ani.hpp"
#include "override.user.hpp"
#include "override.UIAbility.ani.1.h"
static ani_object override_getUIAbility_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::override::UIAbility cpp_result = ::override::getUIAbility();
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = override_UIAbility_intoANI(env, cpp_result);
    return ani_result;
}
static void override_useUIAbility_ANIFunc([[maybe_unused]] ani_env *env, ani_object ani_arg_a) {
    ::taihe::set_env(env);
    ::override::UIAbility cpp_arg_a = override_UIAbility_fromANI(env, ani_arg_a);
    ::override::useUIAbility(cpp_arg_a);
}
static void override_UIAbility_onForeground_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    override_UIAbility_vtable* cpp_vtbl_ptr = reinterpret_cast<override_UIAbility_vtable*>(ani_vtbl_ptr);
    ::override::weak::UIAbility cpp_iface = ::override::weak::UIAbility({cpp_vtbl_ptr, cpp_data_ptr});
    ::override::weak::UIAbility(cpp_iface)->onForeground();
}
static void override_UIAbility_onBackground_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    override_UIAbility_vtable* cpp_vtbl_ptr = reinterpret_cast<override_UIAbility_vtable*>(ani_vtbl_ptr);
    ::override::weak::UIAbility cpp_iface = ::override::weak::UIAbility({cpp_vtbl_ptr, cpp_data_ptr});
    ::override::weak::UIAbility(cpp_iface)->onBackground();
}
namespace override {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Loverride;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"getUIAbility_inner", nullptr, reinterpret_cast<void*>(override_getUIAbility_ANIFunc)},

            {"useUIAbility_inner", nullptr, reinterpret_cast<void*>(override_useUIAbility_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Loverride/UIAbility;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"onForeground_inner", nullptr, reinterpret_cast<void*>(override_UIAbility_onForeground_ANIFunc)},

            {"onBackground_inner", nullptr, reinterpret_cast<void*>(override_UIAbility_onBackground_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
