#pragma once
#include "hms.core.map.map_inner.map_inner.ani.0.h"
#include "hms.core.map.map_inner.map_inner.proj.2.hpp"
#include "hms.core.map.map_inner.icons_type.ani.1.h"
#include "hms.core.map.map_inner.Resource.ani.1.h"
inline ::hms::core::map::map_inner::map_inner hms_core_map_map_inner_map_inner_fromANI32(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        ::taihe::string getId() {
            ani_string ani_result;
            this->env->Object_CallMethodByName_Ref(this->ref, "getId", nullptr, reinterpret_cast<ani_ref*>(&ani_result));

        ani_size cpp_result_len;
        this->env->String_GetUTF8Size(ani_result, &cpp_result_len);
        TString cpp_result_tstr;
        char* cpp_result_buf = tstr_initialize(&cpp_result_tstr, cpp_result_len + 1);
        this->env->String_GetUTF8(ani_result, cpp_result_buf, cpp_result_len + 1, &cpp_result_len);
        cpp_result_buf[cpp_result_len] = '\0';
        cpp_result_tstr.length = cpp_result_len;
        taihe::string cpp_result = taihe::string(cpp_result_tstr);
            return cpp_result;
        }
        int32_t getZIndex() {
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "getZIndex", nullptr, reinterpret_cast<ani_int*>(&ani_result));

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        int32_t getMaxZoom() {
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "getMaxZoom", nullptr, reinterpret_cast<ani_int*>(&ani_result));

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        int32_t getMinZoom() {
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "getMinZoom", nullptr, reinterpret_cast<ani_int*>(&ani_result));

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        int32_t setIcons_sync(::taihe::array_view<::hms::core::map::map_inner::icons_type> cpp_arg_icons) {
        size_t ani_arg_icons_size = cpp_arg_icons.size();
        ani_array_ref ani_arg_icons;
        ani_class ani_arg_icons_cls;
        this->env->FindClass("Lstd/core/Object;", &ani_arg_icons_cls);
ani_ref ani_undefined;
        this->env->GetUndefined(&ani_undefined);
        this->env->Array_New_Ref(ani_arg_icons_cls, ani_arg_icons_size, ani_undefined, &ani_arg_icons);
        for (size_t ani_arg_icons_i = 0; ani_arg_icons_i < ani_arg_icons_size; ani_arg_icons_i++) {
            ani_ref ani_arg_icons_item = hms_core_map_map_inner_icons_type_intoANI32(this->env, cpp_arg_icons.data()[ani_arg_icons_i]);
            this->env->Array_Set_Ref(ani_arg_icons, ani_arg_icons_i, ani_arg_icons_item);
        }
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "setIcons_sync", nullptr, reinterpret_cast<ani_int*>(&ani_result), ani_arg_icons);

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        void setPositions(::taihe::array_view<::taihe::array<::hms::core::map::map_inner::Resource>> cpp_arg_positions) {
        size_t ani_arg_positions_size = cpp_arg_positions.size();
        ani_array_ref ani_arg_positions;
        ani_class ani_arg_positions_cls;
        this->env->FindClass("[L@hms/core/map/map_inner/Resource;", &ani_arg_positions_cls);
ani_ref ani_undefined;
        this->env->GetUndefined(&ani_undefined);
        this->env->Array_New_Ref(ani_arg_positions_cls, ani_arg_positions_size, ani_undefined, &ani_arg_positions);
        for (size_t ani_arg_positions_i = 0; ani_arg_positions_i < ani_arg_positions_size; ani_arg_positions_i++) {
            size_t ani_arg_positions_item_size = cpp_arg_positions.data()[ani_arg_positions_i].size();
            ani_array_ref ani_arg_positions_item;
            ani_class ani_arg_positions_item_cls;
            this->env->FindClass("L@hms/core/map/map_inner/Resource;", &ani_arg_positions_item_cls);
ani_ref ani_undefined;
            this->env->GetUndefined(&ani_undefined);
            this->env->Array_New_Ref(ani_arg_positions_item_cls, ani_arg_positions_item_size, ani_undefined, &ani_arg_positions_item);
            for (size_t ani_arg_positions_item_i = 0; ani_arg_positions_item_i < ani_arg_positions_item_size; ani_arg_positions_item_i++) {
                ani_object ani_arg_positions_item_item = hms_core_map_map_inner_Resource_intoANI3(this->env, cpp_arg_positions.data()[ani_arg_positions_i].data()[ani_arg_positions_item_i]);
                this->env->Array_Set_Ref(ani_arg_positions_item, ani_arg_positions_item_i, ani_arg_positions_item_item);
            }
            this->env->Array_Set_Ref(ani_arg_positions, ani_arg_positions_i, ani_arg_positions_item);
        }
            this->env->Object_CallMethodByName_Void(this->ref, "setPositions", nullptr, ani_arg_positions);

        }
    };
    return taihe::make_holder<cpp_impl_t, ::hms::core::map::map_inner::map_inner>(env, ani_obj);
}
inline ani_object hms_core_map_map_inner_map_inner_intoANI32(ani_env* env, ::hms::core::map::map_inner::map_inner cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("L@hms/core/map/map_inner/map_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
