#include "arrbuffer.ani.hpp"
#include "arrbuffer.user.hpp"
static ani_int arrbuffer_convert2Int_ANIFunc([[maybe_unused]] ani_env *env, ani_arraybuffer ani_arg_a) {
    ::taihe::set_env(env);
    char* cpp_arg_a_data = nullptr;
    size_t cpp_arg_a_length = 0;
    env->ArrayBuffer_GetInfo(reinterpret_cast<ani_arraybuffer>(ani_arg_a), reinterpret_cast<void**>(&cpp_arg_a_data), &cpp_arg_a_length);
    ::taihe::array_view<uint8_t> cpp_arg_a(reinterpret_cast<uint8_t*>(cpp_arg_a_data), cpp_arg_a_length / (sizeof(uint8_t) / sizeof(char)));
    int32_t cpp_result = ::arrbuffer::convert2Int(cpp_arg_a);
    if (::taihe::has_error()) { return ani_int{}; }
    ani_int ani_result = (int32_t)cpp_result;
    return ani_result;
}
namespace arrbuffer {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Larrbuffer;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"convert2Int_inner", nullptr, reinterpret_cast<void*>(arrbuffer_convert2Int_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
