#include "basic_abilities.ani.hpp"
#include "basic_abilities.user.hpp"
static ani_array_ref basic_abilities_convert_arr_ANIFunc02([[maybe_unused]] ani_env *env, ani_array_int ani_arg_a, ani_string ani_arg_str) {
    ::taihe::set_env(env);
    size_t cpp_arg_a_size;
    env->Array_GetLength(ani_arg_a, &cpp_arg_a_size);
    int32_t* cpp_arg_a_buffer = (int32_t*)malloc(cpp_arg_a_size * sizeof(int32_t));
    env->Array_GetRegion_Int(ani_arg_a, 0, cpp_arg_a_size, reinterpret_cast<ani_int*>(cpp_arg_a_buffer));
    ::taihe::array<int32_t> cpp_arg_a(cpp_arg_a_buffer, cpp_arg_a_size);
    ani_size cpp_arg_str_len;
    env->String_GetUTF8Size(ani_arg_str, &cpp_arg_str_len);
    TString cpp_arg_str_tstr;
    char* cpp_arg_str_buf = tstr_initialize(&cpp_arg_str_tstr, cpp_arg_str_len + 1);
    env->String_GetUTF8(ani_arg_str, cpp_arg_str_buf, cpp_arg_str_len + 1, &cpp_arg_str_len);
    cpp_arg_str_buf[cpp_arg_str_len] = '\0';
    cpp_arg_str_tstr.length = cpp_arg_str_len;
    taihe::string cpp_arg_str = taihe::string(cpp_arg_str_tstr);
    ::taihe::array<::taihe::string> cpp_result = ::basic_abilities::convert_arr(cpp_arg_a, cpp_arg_str);
    if (::taihe::has_error()) { return ani_array_ref{}; }
    size_t ani_result_size = cpp_result.size();
    ani_array_ref ani_result;
    ani_class ani_result_cls;
    env->FindClass("Lstd/core/String;", &ani_result_cls);
ani_ref ani_undefined;
    env->GetUndefined(&ani_undefined);
    env->Array_New_Ref(ani_result_cls, ani_result_size, ani_undefined, &ani_result);
    for (size_t ani_result_i = 0; ani_result_i < ani_result_size; ani_result_i++) {
        ani_string ani_result_item;
        env->String_NewUTF8(cpp_result.data()[ani_result_i].c_str(), cpp_result.data()[ani_result_i].size(), &ani_result_item);
        env->Array_Set_Ref(ani_result, ani_result_i, ani_result_item);
    }
    return ani_result;
}
namespace basic_abilities {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Lbasic_abilities;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"convert_arr_inner", nullptr, reinterpret_cast<void*>(basic_abilities_convert_arr_ANIFunc02)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
