#pragma once
#include "binding.Color.ani.0.h"
#include "binding.Color.proj.1.hpp"
inline ::binding::Color binding_Color_fromANI(ani_env* env, ani_object ani_obj) {
    ani_int ani_field_R;
    env->Object_GetPropertyByName_Int(ani_obj, "R", reinterpret_cast<ani_int*>(&ani_field_R));

    int32_t cpp_field_R = (int32_t)ani_field_R;
    ani_int ani_field_G;
    env->Object_GetPropertyByName_Int(ani_obj, "G", reinterpret_cast<ani_int*>(&ani_field_G));

    int32_t cpp_field_G = (int32_t)ani_field_G;
    ani_int ani_field_B;
    env->Object_GetPropertyByName_Int(ani_obj, "B", reinterpret_cast<ani_int*>(&ani_field_B));

    int32_t cpp_field_B = (int32_t)ani_field_B;
    return ::binding::Color{std::move(cpp_field_R), std::move(cpp_field_G), std::move(cpp_field_B)};
}
inline ani_object binding_Color_intoANI(ani_env* env, ::binding::Color const& cpp_obj) {
    ani_int ani_field_R = (int32_t)cpp_obj.R;
    ani_int ani_field_G = (int32_t)cpp_obj.G;
    ani_int ani_field_B = (int32_t)cpp_obj.B;
    ani_class ani_obj_cls;
    env->FindClass("Lbinding/Color_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_field_R, ani_field_G, ani_field_B);
    return ani_obj;
}
