#pragma once
#include "ohos.book.store.Bookstore.ani.0.h"
#include "ohos.book.store.Bookstore.proj.2.hpp"
#include "ohos.book.store.Book.ani.1.h"
inline ::ohos::book::store::Bookstore ohos_book_store_Bookstore_fromANI(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        void addBook(::ohos::book::store::Book const& cpp_arg_book, double cpp_arg_price, int32_t cpp_arg_count) {
        ani_object ani_arg_book = ohos_book_store_Book_intoANI(this->env, cpp_arg_book);
        ani_double ani_arg_price = (double)cpp_arg_price;
        ani_int ani_arg_count = (int32_t)cpp_arg_count;
            this->env->Object_CallMethodByName_Void(this->ref, "addBook", nullptr, ani_arg_book, ani_arg_price, ani_arg_count);

        }
        void saleBook(::ohos::book::store::Book const& cpp_arg_book) {
        ani_object ani_arg_book = ohos_book_store_Book_intoANI(this->env, cpp_arg_book);
            this->env->Object_CallMethodByName_Void(this->ref, "saleBook", nullptr, ani_arg_book);

        }
        double getDiscount() {
            ani_double ani_result;
            this->env->Object_CallMethodByName_Double(this->ref, "<get>discount", nullptr, reinterpret_cast<ani_double*>(&ani_result));

        double cpp_result = (double)ani_result;
            return cpp_result;
        }
        void setDiscount(double cpp_arg_percent) {
        ani_double ani_arg_percent = (double)cpp_arg_percent;
            this->env->Object_CallMethodByName_Void(this->ref, "<set>discount", nullptr, ani_arg_percent);

        }
        double getTotalSales() {
            ani_double ani_result;
            this->env->Object_CallMethodByName_Double(this->ref, "<get>totalSales", nullptr, reinterpret_cast<ani_double*>(&ani_result));

        double cpp_result = (double)ani_result;
            return cpp_result;
        }
    };
    return taihe::make_holder<cpp_impl_t, ::ohos::book::store::Bookstore>(env, ani_obj);
}
inline ani_object ohos_book_store_Bookstore_intoANI(ani_env* env, ::ohos::book::store::Bookstore cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Lohos/book/store/Bookstore;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
