#pragma once
#include "taihe/common.hpp"
#include "ohos.book.store.CppBook.proj.0.hpp"
#include "ohos.book.store.CppBook.abi.1.h"
#include "ohos.book.store.Book.proj.1.hpp"
#include "taihe/string.hpp"
namespace ohos::book::store {
struct CppBook {
    ::ohos::book::store::Book base;
    ::taihe::string compiler;
};
}
namespace taihe {
inline auto hash_impl(adl_helper_t, ::ohos::book::store::CppBook const& val) -> ::std::size_t {
    ::std::size_t seed = 0;
    seed ^= hash(val.base) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    seed ^= hash(val.compiler) + 0x9e3779b9 + (seed << 6) + (seed >> 2);
    return seed;
}
}
namespace taihe {
inline bool same_impl(adl_helper_t, ::ohos::book::store::CppBook const& lhs, ::ohos::book::store::CppBook const& rhs) {
    return true && same(lhs.base, rhs.base) && same(lhs.compiler, rhs.compiler);
}
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::CppBook> {
    using type = struct ohos_book_store_CppBook_t;
};
template<>
struct as_abi<::ohos::book::store::CppBook const&> {
    using type = struct ohos_book_store_CppBook_t const*;
};
template<>
struct as_param<::ohos::book::store::CppBook> {
    using type = ::ohos::book::store::CppBook const&;
};
}
