#pragma once
#include "ohos.book.store.CppOrRustBook.ani.0.h"
#include "ohos.book.store.CppOrRustBook.proj.1.hpp"
#include "ohos.book.store.RustBook.ani.1.h"
#include "ohos.book.store.CppBook.ani.1.h"
inline ::ohos::book::store::CppOrRustBook ohos_book_store_CppOrRustBook_fromANI(ani_env* env, ani_ref ani_value) {
    ani_class ani_cls_rust;
    env->FindClass("Lohos/book/store/RustBook;", &ani_cls_rust);
    ani_boolean ani_is_rust;
    env->Object_InstanceOf((ani_object)ani_value, ani_cls_rust, &ani_is_rust);
    if (ani_is_rust) {
        ::ohos::book::store::RustBook cpp_field_rust = ohos_book_store_RustBook_fromANI(env, static_cast<ani_object>(ani_value));
        return ::ohos::book::store::CppOrRustBook(taihe::static_tag<::ohos::book::store::CppOrRustBook::tag_t::rust>, std::move(cpp_field_rust));
    }
    ani_class ani_cls_cpp;
    env->FindClass("Lohos/book/store/CppBook;", &ani_cls_cpp);
    ani_boolean ani_is_cpp;
    env->Object_InstanceOf((ani_object)ani_value, ani_cls_cpp, &ani_is_cpp);
    if (ani_is_cpp) {
        ::ohos::book::store::CppBook cpp_field_cpp = ohos_book_store_CppBook_fromANI(env, static_cast<ani_object>(ani_value));
        return ::ohos::book::store::CppOrRustBook(taihe::static_tag<::ohos::book::store::CppOrRustBook::tag_t::cpp>, std::move(cpp_field_cpp));
    }
    __builtin_unreachable();
}
inline ani_ref ohos_book_store_CppOrRustBook_intoANI(ani_env* env, ::ohos::book::store::CppOrRustBook const& cpp_value) {
    ani_ref ani_value;
    switch (cpp_value.get_tag()) {
    case ::ohos::book::store::CppOrRustBook::tag_t::rust: {
        ani_object ani_field_rust = ohos_book_store_RustBook_intoANI(env, cpp_value.get_rust_ref());
        ani_value = ani_field_rust;
        break;
    }
    case ::ohos::book::store::CppOrRustBook::tag_t::cpp: {
        ani_object ani_field_cpp = ohos_book_store_CppBook_intoANI(env, cpp_value.get_cpp_ref());
        ani_value = ani_field_cpp;
        break;
    }
    }
    return ani_value;
}
