#pragma once
#include "taihe/object.hpp"
#include "ohos.book.store.HasDiscount.proj.0.hpp"
#include "ohos.book.store.HasDiscount.abi.1.h"
#include "ohos.book.store.HasPrice.proj.1.hpp"
namespace ohos::book::store::weak {
struct HasDiscount {
    static constexpr bool is_holder = false;
    struct ohos_book_store_HasDiscount_t m_handle;
    explicit HasDiscount(struct ohos_book_store_HasDiscount_t handle) : m_handle(handle) {}
    explicit HasDiscount(::taihe::data_view other)
        : HasDiscount(ohos_book_store_HasDiscount_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = ohos_book_store_HasDiscount_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::ohos::book::store::weak::HasPrice() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasPrice(ohos_book_store_HasDiscount_1_static(ret_handle));
    }
    operator ::ohos::book::store::HasPrice() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = ohos_book_store_HasDiscount_copy(m_handle);
        return ::ohos::book::store::HasPrice(ohos_book_store_HasDiscount_1_static(ret_handle));
    }
    struct virtual_type {
        double getDiscount() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static double getDiscount(struct ohos_book_store_HasDiscount_t tobj);
    };
    template<typename Impl>
    static constexpr ohos_book_store_HasDiscount_ftable ftbl_impl = {
        .getDiscount = &methods_impl<Impl>::getDiscount,
    };
    template<typename Impl>
    static constexpr ohos_book_store_HasDiscount_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::ohos::book::store::weak::HasDiscount::template ftbl_impl<Impl>,
        .ftbl_ptr_1 = &::ohos::book::store::weak::HasPrice::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[2] = {
        {&ohos_book_store_HasDiscount_i, &vtbl_impl<Impl>.ftbl_ptr_0},
        {&ohos_book_store_HasPrice_i, &vtbl_impl<Impl>.ftbl_ptr_1},
    };
    static constexpr void const* iid = &ohos_book_store_HasDiscount_i;
    using vtable_t = ohos_book_store_HasDiscount_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ohos::book::store {
struct HasDiscount : public ::ohos::book::store::weak::HasDiscount {
    static constexpr bool is_holder = true;
    explicit HasDiscount(struct ohos_book_store_HasDiscount_t handle) : ::ohos::book::store::weak::HasDiscount(handle) {}
    HasDiscount& operator=(::ohos::book::store::HasDiscount other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~HasDiscount() {
        ohos_book_store_HasDiscount_drop(m_handle);
    }
    explicit HasDiscount(::taihe::data_holder other)
        : HasDiscount(ohos_book_store_HasDiscount_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = ohos_book_store_HasDiscount_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ohos_book_store_HasDiscount_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    HasDiscount(::ohos::book::store::weak::HasDiscount const& other)
        : HasDiscount(ohos_book_store_HasDiscount_copy(other.m_handle)) {}
    HasDiscount(::ohos::book::store::HasDiscount const& other)
        : HasDiscount(ohos_book_store_HasDiscount_copy(other.m_handle)) {}
    HasDiscount(::ohos::book::store::HasDiscount&& other)
        : HasDiscount(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
    operator ::ohos::book::store::weak::HasPrice() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = m_handle;
        return ::ohos::book::store::weak::HasPrice(ohos_book_store_HasDiscount_1_static(ret_handle));
    }
    operator ::ohos::book::store::HasPrice() const& {
        struct ohos_book_store_HasDiscount_t ret_handle = ohos_book_store_HasDiscount_copy(m_handle);
        return ::ohos::book::store::HasPrice(ohos_book_store_HasDiscount_1_static(ret_handle));
    }
    operator ::ohos::book::store::HasPrice() && {
        struct ohos_book_store_HasDiscount_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::ohos::book::store::HasPrice(ohos_book_store_HasDiscount_1_static(ret_handle));
    }
};
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::HasDiscount> {
    using type = struct ohos_book_store_HasDiscount_t;
};
template<>
struct as_abi<::ohos::book::store::weak::HasDiscount> {
    using type = struct ohos_book_store_HasDiscount_t;
};
template<>
struct as_param<::ohos::book::store::HasDiscount> {
    using type = ::ohos::book::store::weak::HasDiscount;
};
}
