#pragma once
#include "taihe/object.hpp"
#include "ohos.book.store.HasPublisher.proj.0.hpp"
#include "ohos.book.store.HasPublisher.abi.1.h"
#include "taihe/string.hpp"
namespace ohos::book::store::weak {
struct HasPublisher {
    static constexpr bool is_holder = false;
    struct ohos_book_store_HasPublisher_t m_handle;
    explicit HasPublisher(struct ohos_book_store_HasPublisher_t handle) : m_handle(handle) {}
    explicit HasPublisher(::taihe::data_view other)
        : HasPublisher(ohos_book_store_HasPublisher_dynamic(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ohos_book_store_HasPublisher_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_HasPublisher_t ret_handle = ohos_book_store_HasPublisher_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        ::taihe::string getPublisher() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static struct TString getPublisher(struct ohos_book_store_HasPublisher_t tobj);
    };
    template<typename Impl>
    static constexpr ohos_book_store_HasPublisher_ftable ftbl_impl = {
        .getPublisher = &methods_impl<Impl>::getPublisher,
    };
    template<typename Impl>
    static constexpr ohos_book_store_HasPublisher_vtable vtbl_impl = {
        .ftbl_ptr_0 = &::ohos::book::store::weak::HasPublisher::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&ohos_book_store_HasPublisher_i, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &ohos_book_store_HasPublisher_i;
    using vtable_t = ohos_book_store_HasPublisher_vtable;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ohos::book::store {
struct HasPublisher : public ::ohos::book::store::weak::HasPublisher {
    static constexpr bool is_holder = true;
    explicit HasPublisher(struct ohos_book_store_HasPublisher_t handle) : ::ohos::book::store::weak::HasPublisher(handle) {}
    HasPublisher& operator=(::ohos::book::store::HasPublisher other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~HasPublisher() {
        ohos_book_store_HasPublisher_drop(m_handle);
    }
    explicit HasPublisher(::taihe::data_holder other)
        : HasPublisher(ohos_book_store_HasPublisher_dynamic(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ohos_book_store_HasPublisher_t ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ohos_book_store_HasPublisher_t ret_handle = ohos_book_store_HasPublisher_copy(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ohos_book_store_HasPublisher_t ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    HasPublisher(::ohos::book::store::weak::HasPublisher const& other)
        : HasPublisher(ohos_book_store_HasPublisher_copy(other.m_handle)) {}
    HasPublisher(::ohos::book::store::HasPublisher const& other)
        : HasPublisher(ohos_book_store_HasPublisher_copy(other.m_handle)) {}
    HasPublisher(::ohos::book::store::HasPublisher&& other)
        : HasPublisher(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::ohos::book::store::HasPublisher> {
    using type = struct ohos_book_store_HasPublisher_t;
};
template<>
struct as_abi<::ohos::book::store::weak::HasPublisher> {
    using type = struct ohos_book_store_HasPublisher_t;
};
template<>
struct as_param<::ohos::book::store::HasPublisher> {
    using type = ::ohos::book::store::weak::HasPublisher;
};
}
