#pragma once
#include "ohos.book.store.MapOption.ani.0.h"
#include "ohos.book.store.MapOption.proj.1.hpp"
#include "ohos.book.store.Book.ani.1.h"
inline ::ohos::book::store::MapOption ohos_book_store_MapOption_fromANI(ani_env* env, ani_ref ani_value) {
    ani_class ani_cls_one_book;
    env->FindClass("Lohos/book/store/Book;", &ani_cls_one_book);
    ani_boolean ani_is_one_book;
    env->Object_InstanceOf((ani_object)ani_value, ani_cls_one_book, &ani_is_one_book);
    if (ani_is_one_book) {
        ::ohos::book::store::Book cpp_field_one_book = ohos_book_store_Book_fromANI(env, static_cast<ani_object>(ani_value));
        return ::ohos::book::store::MapOption(taihe::static_tag<::ohos::book::store::MapOption::tag_t::one_book>, std::move(cpp_field_one_book));
    }
    ani_class ani_cls_many_books;
    env->FindClass("[Lohos/book/store/Book;", &ani_cls_many_books);
    ani_boolean ani_is_many_books;
    env->Object_InstanceOf((ani_object)ani_value, ani_cls_many_books, &ani_is_many_books);
    if (ani_is_many_books) {
        size_t cpp_field_many_books_size;
        env->Array_GetLength(static_cast<ani_array_ref>(ani_value), &cpp_field_many_books_size);
        ::ohos::book::store::Book* cpp_field_many_books_buffer = (::ohos::book::store::Book*)malloc(cpp_field_many_books_size * sizeof(::ohos::book::store::Book));
        for (size_t cpp_field_many_books_buffer_i = 0; cpp_field_many_books_buffer_i < cpp_field_many_books_size; cpp_field_many_books_buffer_i++) {
            ani_object cpp_field_many_books_buffer_ani_item;
            env->Array_Get_Ref(static_cast<ani_array_ref>(ani_value), cpp_field_many_books_buffer_i, reinterpret_cast<ani_ref*>(&cpp_field_many_books_buffer_ani_item));
            ::ohos::book::store::Book cpp_field_many_books_buffer_cpp_item = ohos_book_store_Book_fromANI(env, cpp_field_many_books_buffer_ani_item);
            new (&cpp_field_many_books_buffer[cpp_field_many_books_buffer_i]) ::ohos::book::store::Book(std::move(cpp_field_many_books_buffer_cpp_item));
        }
        ::taihe::array<::ohos::book::store::Book> cpp_field_many_books(cpp_field_many_books_buffer, cpp_field_many_books_size);
        return ::ohos::book::store::MapOption(taihe::static_tag<::ohos::book::store::MapOption::tag_t::many_books>, std::move(cpp_field_many_books));
    }
    __builtin_unreachable();
}
inline ani_ref ohos_book_store_MapOption_intoANI(ani_env* env, ::ohos::book::store::MapOption const& cpp_value) {
    ani_ref ani_value;
    switch (cpp_value.get_tag()) {
    case ::ohos::book::store::MapOption::tag_t::one_book: {
        ani_object ani_field_one_book = ohos_book_store_Book_intoANI(env, cpp_value.get_one_book_ref());
        ani_value = ani_field_one_book;
        break;
    }
    case ::ohos::book::store::MapOption::tag_t::many_books: {
        size_t ani_field_many_books_size = cpp_value.get_many_books_ref().size();
        ani_array_ref ani_field_many_books;
        ani_class ani_field_many_books_cls;
        env->FindClass("Lohos/book/store/Book;", &ani_field_many_books_cls);
ani_ref ani_undefined;
        env->GetUndefined(&ani_undefined);
        env->Array_New_Ref(ani_field_many_books_cls, ani_field_many_books_size, ani_undefined, &ani_field_many_books);
        for (size_t ani_field_many_books_i = 0; ani_field_many_books_i < ani_field_many_books_size; ani_field_many_books_i++) {
            ani_object ani_field_many_books_item = ohos_book_store_Book_intoANI(env, cpp_value.get_many_books_ref().data()[ani_field_many_books_i]);
            env->Array_Set_Ref(ani_field_many_books, ani_field_many_books_i, ani_field_many_books_item);
        }
        ani_value = ani_field_many_books;
        break;
    }
    }
    return ani_value;
}
