#pragma once
#include "ohos.book.store.Book.abi.1.h"
#include "ohos.book.store.RustBook.abi.1.h"
#include "ohos.book.store.CppBook.abi.1.h"
#include "ohos.book.store.MapOption.abi.1.h"
#include "ohos.book.store.CppOrRustBook.abi.1.h"
#include "ohos.book.store.Bookstore.abi.2.h"
#include "ohos.book.store.HasPrice.abi.2.h"
#include "ohos.book.store.HasDiscount.abi.2.h"
#include "ohos.book.store.HasPublisher.abi.2.h"
#include "ohos.book.store.FancyBook.abi.2.h"
#include "ohos.book.store.Path.abi.2.h"
#include "ohos.book.store.Foo.abi.2.h"
#include "taihe/common.h"
#include "taihe/string.abi.h"
#include "ohos.book.store.Book.abi.0.h"
#include "ohos.book.store.MapOption.abi.0.h"
#include "taihe/array.abi.h"
#include "taihe/optional.abi.h"
#include "ohos.book.store.Bookstore.abi.0.h"
#include "ohos.book.store.CppOrRustBook.abi.0.h"
#include "ohos.book.store.FancyBook.abi.0.h"
#include "ohos.book.store.Path.abi.0.h"
TH_EXPORT struct ohos_book_store_Book_t ohos_book_store_ConstructBook_f(struct TString title, int32_t year, int kind);
TH_EXPORT void ohos_book_store_PrintBook_f(struct ohos_book_store_Book_t const* b);
TH_EXPORT void* ohos_book_store_MapBookToYear_f(struct ohos_book_store_MapOption_t const* opt);
TH_EXPORT void ohos_book_store_PrintBooksWithFilter_f(struct TArray books, struct TOptional filter);
TH_EXPORT struct ohos_book_store_Bookstore_t ohos_book_store_CreateBookstore_f();
TH_EXPORT void ohos_book_store_SayHello_f();
TH_EXPORT void ohos_book_store_PrintBookAdvanced_f(struct ohos_book_store_CppOrRustBook_t const* book);
TH_EXPORT struct ohos_book_store_FancyBook_t ohos_book_store_MakeFancyBook_f();
TH_EXPORT void ohos_book_store_SaveBookToInternet_f(struct TString url);
TH_EXPORT void ohos_book_store_SaveBookToFile_f(struct ohos_book_store_Path_t p);
TH_EXPORT struct TString ohos_book_store_uploadBook_f(struct ohos_book_store_Book_t const* b);
TH_EXPORT void ohos_book_store_onBookSold_f();
TH_EXPORT void ohos_book_store_onNewBook_f();
TH_EXPORT bool ohos_book_store_IsString_f(uintptr_t s);
TH_EXPORT struct TArray ohos_book_store_GetStringArray_f();
