#include "external_obj.ani.hpp"
#include "external_obj.user.hpp"
static ani_boolean external_obj_is_string_ANIFunc02([[maybe_unused]] ani_env *env, ani_ref ani_arg_s) {
    ::taihe::set_env(env);
    uintptr_t cpp_arg_s = (uintptr_t)ani_arg_s;
    bool cpp_result = ::external_obj::is_string(cpp_arg_s);
    if (::taihe::has_error()) { return ani_boolean{}; }
    ani_boolean ani_result = (bool)cpp_result;
    return ani_result;
}
static ani_array_ref external_obj_get_objects_ANIFunc02([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::taihe::array<uintptr_t> cpp_result = ::external_obj::get_objects();
    if (::taihe::has_error()) { return ani_array_ref{}; }
    size_t ani_result_size = cpp_result.size();
    ani_array_ref ani_result;
    ani_class ani_result_cls;
    env->FindClass("Lstd/core/Object;", &ani_result_cls);
ani_ref ani_undefined;
    env->GetUndefined(&ani_undefined);
    env->Array_New_Ref(ani_result_cls, ani_result_size, ani_undefined, &ani_result);
    for (size_t ani_result_i = 0; ani_result_i < ani_result_size; ani_result_i++) {
        ani_ref ani_result_item = (ani_ref)cpp_result.data()[ani_result_i];
        env->Array_Set_Ref(ani_result, ani_result_i, ani_result_item);
    }
    return ani_result;
}
namespace external_obj {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Lexternal_obj;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"is_string_inner", nullptr, reinterpret_cast<void*>(external_obj_is_string_ANIFunc02)},

            {"get_objects_inner", nullptr, reinterpret_cast<void*>(external_obj_get_objects_ANIFunc02)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
