#include "hello_world.ani.hpp"
#include "hello_world.user.hpp"
static ani_string hello_world_add_ANIFunc0([[maybe_unused]] ani_env *env, ani_int ani_arg_a, ani_int ani_arg_b) {
    ::taihe::set_env(env);
    int32_t cpp_arg_a = (int32_t)ani_arg_a;
    int32_t cpp_arg_b = (int32_t)ani_arg_b;
    ::taihe::string cpp_result = ::hello_world::add(cpp_arg_a, cpp_arg_b);
    if (::taihe::has_error()) { return ani_string{}; }
    ani_string ani_result;
    env->String_NewUTF8(cpp_result.c_str(), cpp_result.size(), &ani_result);
    return ani_result;
}
namespace hello_world {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Lhello_world;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"add_inner", nullptr, reinterpret_cast<void*>(hello_world_add_ANIFunc0)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
