#pragma once
#include "notification.INotificationService.ani.0.h"
#include "notification.INotificationService.proj.2.hpp"
#include "user.IUser.ani.1.h"
inline ::notification::INotificationService notification_INotificationService_fromANI(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        void sendMessage(::user::weak::IUser cpp_arg_a) {
        ani_object ani_arg_a = user_IUser_intoANI(this->env, cpp_arg_a);
            this->env->Object_CallMethodByName_Void(this->ref, "sendMessage", nullptr, ani_arg_a);

        }
    };
    return taihe::make_holder<cpp_impl_t, ::notification::INotificationService>(env, ani_obj);
}
inline ani_object notification_INotificationService_intoANI(ani_env* env, ::notification::INotificationService cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Lnotification/INotificationService_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
