#include "notification.ani.hpp"
#include "notification.user.hpp"
#include "notification.INotificationService.ani.1.h"
#include "user.IUser.ani.1.h"
static ani_object notification_makeNotificationService_ANIFunc([[maybe_unused]] ani_env *env) {
    ::taihe::set_env(env);
    ::notification::INotificationService cpp_result = ::notification::makeNotificationService();
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = notification_INotificationService_intoANI(env, cpp_result);
    return ani_result;
}
static void notification_INotificationService_sendMessage_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_object ani_arg_a) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    notification_INotificationService_vtable* cpp_vtbl_ptr = reinterpret_cast<notification_INotificationService_vtable*>(ani_vtbl_ptr);
    ::notification::weak::INotificationService cpp_iface = ::notification::weak::INotificationService({cpp_vtbl_ptr, cpp_data_ptr});
    ::user::IUser cpp_arg_a = user_IUser_fromANI(env, ani_arg_a);
    ::notification::weak::INotificationService(cpp_iface)->sendMessage(cpp_arg_a);
}
namespace notification {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Lnotification;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"makeNotificationService_inner", nullptr, reinterpret_cast<void*>(notification_makeNotificationService_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Lnotification/INotificationService_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"sendMessage_inner", nullptr, reinterpret_cast<void*>(notification_INotificationService_sendMessage_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
