#include "user.ani.hpp"
#include "user.user.hpp"
#include "user.IUser.ani.1.h"
static ani_object user_makeUser_ANIFunc([[maybe_unused]] ani_env *env, ani_string ani_arg_path) {
    ::taihe::set_env(env);
    ani_size cpp_arg_path_len;
    env->String_GetUTF8Size(ani_arg_path, &cpp_arg_path_len);
    TString cpp_arg_path_tstr;
    char* cpp_arg_path_buf = tstr_initialize(&cpp_arg_path_tstr, cpp_arg_path_len + 1);
    env->String_GetUTF8(ani_arg_path, cpp_arg_path_buf, cpp_arg_path_len + 1, &cpp_arg_path_len);
    cpp_arg_path_buf[cpp_arg_path_len] = '\0';
    cpp_arg_path_tstr.length = cpp_arg_path_len;
    taihe::string cpp_arg_path = taihe::string(cpp_arg_path_tstr);
    ::user::IUser cpp_result = ::user::makeUser(cpp_arg_path);
    if (::taihe::has_error()) { return ani_object{}; }
    ani_object ani_result = user_IUser_intoANI(env, cpp_result);
    return ani_result;
}
static ani_string user_IUser_getEmail_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    user_IUser_vtable* cpp_vtbl_ptr = reinterpret_cast<user_IUser_vtable*>(ani_vtbl_ptr);
    ::user::weak::IUser cpp_iface = ::user::weak::IUser({cpp_vtbl_ptr, cpp_data_ptr});
    ::taihe::string cpp_result = ::user::weak::IUser(cpp_iface)->getEmail();
    if (::taihe::has_error()) { return ani_string{}; }
    ani_string ani_result;
    env->String_NewUTF8(cpp_result.c_str(), cpp_result.size(), &ani_result);
    return ani_result;
}
static void user_IUser_setEmail_ANIFunc([[maybe_unused]] ani_env *env, [[maybe_unused]] ani_object object, ani_string ani_arg_path) {
    ::taihe::set_env(env);
    ani_long ani_data_ptr;
    env->Object_GetPropertyByName_Long(object, "_data_ptr", reinterpret_cast<ani_long*>(&ani_data_ptr));
    ani_long ani_vtbl_ptr;
    env->Object_GetPropertyByName_Long(object, "_vtbl_ptr", reinterpret_cast<ani_long*>(&ani_vtbl_ptr));
    DataBlockHead* cpp_data_ptr = reinterpret_cast<DataBlockHead*>(ani_data_ptr);
    user_IUser_vtable* cpp_vtbl_ptr = reinterpret_cast<user_IUser_vtable*>(ani_vtbl_ptr);
    ::user::weak::IUser cpp_iface = ::user::weak::IUser({cpp_vtbl_ptr, cpp_data_ptr});
    ani_size cpp_arg_path_len;
    env->String_GetUTF8Size(ani_arg_path, &cpp_arg_path_len);
    TString cpp_arg_path_tstr;
    char* cpp_arg_path_buf = tstr_initialize(&cpp_arg_path_tstr, cpp_arg_path_len + 1);
    env->String_GetUTF8(ani_arg_path, cpp_arg_path_buf, cpp_arg_path_len + 1, &cpp_arg_path_len);
    cpp_arg_path_buf[cpp_arg_path_len] = '\0';
    cpp_arg_path_tstr.length = cpp_arg_path_len;
    taihe::string cpp_arg_path = taihe::string(cpp_arg_path_tstr);
    ::user::weak::IUser(cpp_iface)->setEmail(cpp_arg_path);
}
namespace user {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Luser;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"makeUser_inner", nullptr, reinterpret_cast<void*>(user_makeUser_ANIFunc)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    {
        ani_class ani_env;
        if (ANI_OK != env->FindClass("Luser/IUser_inner;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"getEmail_inner", nullptr, reinterpret_cast<void*>(user_IUser_getEmail_ANIFunc)},

            {"setEmail_inner", nullptr, reinterpret_cast<void*>(user_IUser_setEmail_ANIFunc)},

        };
        if (ANI_OK != env->Class_BindNativeMethods(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
