#pragma once
#include "inherit.CreditCard.proj.1.hpp"
#include "inherit.CreditCard.abi.2.h"
#include "inherit.Payable.proj.2.hpp"
namespace inherit::weak {
inline void CreditCard::virtual_type::topUp(double topUpAmount) const& {
    return inherit_CreditCard_topUp_f(*reinterpret_cast<inherit_CreditCard_t const*>(this), ::taihe::into_abi<double>(topUpAmount));
}
}
namespace inherit::weak {
inline double CreditCard::virtual_type::getBalance() const& {
    return ::taihe::from_abi<double>(inherit_CreditCard_getBalance_f(*reinterpret_cast<inherit_CreditCard_t const*>(this)));
}
}
namespace inherit::weak {
inline bool CreditCard::virtual_type::getIntlEnabled() const& {
    return ::taihe::from_abi<bool>(inherit_CreditCard_getIntlEnabled_f(*reinterpret_cast<inherit_CreditCard_t const*>(this)));
}
}
namespace inherit::weak {
inline void CreditCard::virtual_type::setIntlEnabled(bool tag) const& {
    return inherit_CreditCard_setIntlEnabled_f(*reinterpret_cast<inherit_CreditCard_t const*>(this), ::taihe::into_abi<bool>(tag));
}
}
namespace inherit::weak {
template<typename Impl>
void CreditCard::methods_impl<Impl>::topUp(struct inherit_CreditCard_t tobj, double topUpAmount) {
    return ::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->topUp(::taihe::from_abi<double>(topUpAmount));
}
}
namespace inherit::weak {
template<typename Impl>
double CreditCard::methods_impl<Impl>::getBalance(struct inherit_CreditCard_t tobj) {
    return ::taihe::into_abi<double>(::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->getBalance());
}
}
namespace inherit::weak {
template<typename Impl>
bool CreditCard::methods_impl<Impl>::getIntlEnabled(struct inherit_CreditCard_t tobj) {
    return ::taihe::into_abi<bool>(::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->getIntlEnabled());
}
}
namespace inherit::weak {
template<typename Impl>
void CreditCard::methods_impl<Impl>::setIntlEnabled(struct inherit_CreditCard_t tobj, bool tag) {
    return ::taihe::cast_data_ptr<Impl>(tobj.data_ptr)->setIntlEnabled(::taihe::from_abi<bool>(tag));
}
}
