#pragma once
#include "taihe/object.hpp"
#include "class_extends.Context.proj.0.hpp"
#include "class_extends.Context.abi.1.h"
#include "class_extends.BaseContext.proj.1.hpp"
namespace class_extends::weak {
struct Context {
    static constexpr bool is_holder = false;
    struct class_extends_Context_t0 m_handle;
    explicit Context(struct class_extends_Context_t0 handle) : m_handle(handle) {}
    explicit Context(::taihe::data_view other)
        : Context(class_extends_Context_dynamic0(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct class_extends_Context_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct class_extends_Context_t0 ret_handle = class_extends_Context_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::class_extends::weak::BaseContext() const& {
        struct class_extends_Context_t0 ret_handle = m_handle;
        return ::class_extends::weak::BaseContext(class_extends_Context_1_static0(ret_handle));
    }
    operator ::class_extends::BaseContext() const& {
        struct class_extends_Context_t0 ret_handle = class_extends_Context_copy0(m_handle);
        return ::class_extends::BaseContext(class_extends_Context_1_static0(ret_handle));
    }
    struct virtual_type {
        void setStageMode(bool stageMode) const&;
        bool getStageMode() const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void setStageMode(struct class_extends_Context_t0 tobj, bool stageMode);
        static bool getStageMode(struct class_extends_Context_t0 tobj);
    };
    template<typename Impl>
    static constexpr class_extends_Context_ftable0 ftbl_impl = {
        .setStageMode = &methods_impl<Impl>::setStageMode,
        .getStageMode = &methods_impl<Impl>::getStageMode,
    };
    template<typename Impl>
    static constexpr class_extends_Context_vtable0 vtbl_impl = {
        .ftbl_ptr_0 = &::class_extends::weak::Context::template ftbl_impl<Impl>,
        .ftbl_ptr_1 = &::class_extends::weak::BaseContext::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[2] = {
        {&class_extends_Context_i0, &vtbl_impl<Impl>.ftbl_ptr_0},
        {&class_extends_BaseContext_i0, &vtbl_impl<Impl>.ftbl_ptr_1},
    };
    static constexpr void const* iid = &class_extends_Context_i0;
    using vtable_t = class_extends_Context_vtable0;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace class_extends {
struct Context : public ::class_extends::weak::Context {
    static constexpr bool is_holder = true;
    explicit Context(struct class_extends_Context_t0 handle) : ::class_extends::weak::Context(handle) {}
    Context& operator=(::class_extends::Context other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~Context() {
        class_extends_Context_drop0(m_handle);
    }
    explicit Context(::taihe::data_holder other)
        : Context(class_extends_Context_dynamic0(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct class_extends_Context_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct class_extends_Context_t0 ret_handle = class_extends_Context_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct class_extends_Context_t0 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    Context(::class_extends::weak::Context const& other)
        : Context(class_extends_Context_copy0(other.m_handle)) {}
    Context(::class_extends::Context const& other)
        : Context(class_extends_Context_copy0(other.m_handle)) {}
    Context(::class_extends::Context&& other)
        : Context(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
    operator ::class_extends::weak::BaseContext() const& {
        struct class_extends_Context_t0 ret_handle = m_handle;
        return ::class_extends::weak::BaseContext(class_extends_Context_1_static0(ret_handle));
    }
    operator ::class_extends::BaseContext() const& {
        struct class_extends_Context_t0 ret_handle = class_extends_Context_copy0(m_handle);
        return ::class_extends::BaseContext(class_extends_Context_1_static0(ret_handle));
    }
    operator ::class_extends::BaseContext() && {
        struct class_extends_Context_t0 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::class_extends::BaseContext(class_extends_Context_1_static0(ret_handle));
    }
};
}
namespace taihe {
template<>
struct as_abi<::class_extends::Context> {
    using type = struct class_extends_Context_t0;
};
template<>
struct as_abi<::class_extends::weak::Context> {
    using type = struct class_extends_Context_t0;
};
template<>
struct as_param<::class_extends::Context> {
    using type = ::class_extends::weak::Context;
};
}
