#pragma once
#include "interface.ICalculator.ani.0.h"
#include "interface.ICalculator.proj.2.hpp"
inline ::interface::ICalculator interface_ICalculator_fromANI(ani_env* env, ani_object ani_obj) {
    struct cpp_impl_t {
        ani_env* env;
        ani_object ref;
        cpp_impl_t(ani_env* env, ani_object obj) : env(env) {
            this->env->GlobalReference_Create(obj, reinterpret_cast<ani_ref*>(&this->ref));
        }
        ~cpp_impl_t() {
            this->env->GlobalReference_Delete(this->ref);
        }
        int32_t add(int32_t cpp_arg_a, int32_t cpp_arg_b) {
        ani_int ani_arg_a = (int32_t)cpp_arg_a;
        ani_int ani_arg_b = (int32_t)cpp_arg_b;
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "add", nullptr, reinterpret_cast<ani_int*>(&ani_result), ani_arg_a, ani_arg_b);

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        int32_t sub(int32_t cpp_arg_a, int32_t cpp_arg_b) {
        ani_int ani_arg_a = (int32_t)cpp_arg_a;
        ani_int ani_arg_b = (int32_t)cpp_arg_b;
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "sub", nullptr, reinterpret_cast<ani_int*>(&ani_result), ani_arg_a, ani_arg_b);

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        int32_t getLastResult() {
            ani_int ani_result;
            this->env->Object_CallMethodByName_Int(this->ref, "getLastResult", nullptr, reinterpret_cast<ani_int*>(&ani_result));

        int32_t cpp_result = (int32_t)ani_result;
            return cpp_result;
        }
        void reset() {
            this->env->Object_CallMethodByName_Void(this->ref, "reset", nullptr);

        }
    };
    return taihe::make_holder<cpp_impl_t, ::interface::ICalculator>(env, ani_obj);
}
inline ani_object interface_ICalculator_intoANI(ani_env* env, ::interface::ICalculator cpp_obj) {
    ani_long ani_vtbl_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.vtbl_ptr);
    ani_long ani_data_ptr = reinterpret_cast<ani_long>(cpp_obj.m_handle.data_ptr);
    cpp_obj.m_handle.data_ptr = nullptr;
    ani_class ani_obj_cls;
    env->FindClass("Linterface/ICalculator_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_vtbl_ptr, ani_data_ptr);
    return ani_obj;
}
