#pragma once
#include "ns_test.baz.Data.ani.0.h"
#include "ns_test.baz.Data.proj.1.hpp"
inline ::ns_test::baz::Data ns_test_baz_Data_fromANI0(ani_env* env, ani_object ani_obj) {
    ani_string ani_field_a;
    env->Object_GetPropertyByName_Ref(ani_obj, "a", reinterpret_cast<ani_ref*>(&ani_field_a));

    ani_size cpp_field_a_len;
    env->String_GetUTF8Size(ani_field_a, &cpp_field_a_len);
    TString cpp_field_a_tstr;
    char* cpp_field_a_buf = tstr_initialize(&cpp_field_a_tstr, cpp_field_a_len + 1);
    env->String_GetUTF8(ani_field_a, cpp_field_a_buf, cpp_field_a_len + 1, &cpp_field_a_len);
    cpp_field_a_buf[cpp_field_a_len] = '\0';
    cpp_field_a_tstr.length = cpp_field_a_len;
    taihe::string cpp_field_a = taihe::string(cpp_field_a_tstr);
    ani_string ani_field_b;
    env->Object_GetPropertyByName_Ref(ani_obj, "b", reinterpret_cast<ani_ref*>(&ani_field_b));

    ani_size cpp_field_b_len;
    env->String_GetUTF8Size(ani_field_b, &cpp_field_b_len);
    TString cpp_field_b_tstr;
    char* cpp_field_b_buf = tstr_initialize(&cpp_field_b_tstr, cpp_field_b_len + 1);
    env->String_GetUTF8(ani_field_b, cpp_field_b_buf, cpp_field_b_len + 1, &cpp_field_b_len);
    cpp_field_b_buf[cpp_field_b_len] = '\0';
    cpp_field_b_tstr.length = cpp_field_b_len;
    taihe::string cpp_field_b = taihe::string(cpp_field_b_tstr);
    ani_int ani_field_c;
    env->Object_GetPropertyByName_Int(ani_obj, "c", reinterpret_cast<ani_int*>(&ani_field_c));

    int32_t cpp_field_c = (int32_t)ani_field_c;
    return ::ns_test::baz::Data{std::move(cpp_field_a), std::move(cpp_field_b), std::move(cpp_field_c)};
}
inline ani_object ns_test_baz_Data_intoANI0(ani_env* env, ::ns_test::baz::Data const& cpp_obj) {
    ani_string ani_field_a;
    env->String_NewUTF8(cpp_obj.a.c_str(), cpp_obj.a.size(), &ani_field_a);
    ani_string ani_field_b;
    env->String_NewUTF8(cpp_obj.b.c_str(), cpp_obj.b.size(), &ani_field_b);
    ani_int ani_field_c = (int32_t)cpp_obj.c;
    ani_class ani_obj_cls;
    env->FindClass("Lns_test/baz/Data_inner;", &ani_obj_cls);
    ani_method ani_obj_ctor;
    env->Class_FindMethod(ani_obj_cls, "<ctor>", nullptr, &ani_obj_ctor);
    ani_object ani_obj;
    env->Object_New(ani_obj_cls, ani_obj_ctor, &ani_obj, ani_field_a, ani_field_b, ani_field_c);
    return ani_obj;
}
