#pragma once
#include "taihe/object.hpp"
#include "ns_test.foo.window.proj.0.hpp"
#include "ns_test.foo.window.abi.1.h"
namespace ns_test::foo::weak {
struct window {
    static constexpr bool is_holder = false;
    struct ns_test_foo_window_t0 m_handle;
    explicit window(struct ns_test_foo_window_t0 handle) : m_handle(handle) {}
    explicit window(::taihe::data_view other)
        : window(ns_test_foo_window_dynamic0(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct ns_test_foo_window_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ns_test_foo_window_t0 ret_handle = ns_test_foo_window_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        int32_t getheight() const&;
        void setheight(int32_t b) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static int32_t getheight(struct ns_test_foo_window_t0 tobj);
        static void setheight(struct ns_test_foo_window_t0 tobj, int32_t b);
    };
    template<typename Impl>
    static constexpr ns_test_foo_window_ftable0 ftbl_impl = {
        .getheight = &methods_impl<Impl>::getheight,
        .setheight = &methods_impl<Impl>::setheight,
    };
    template<typename Impl>
    static constexpr ns_test_foo_window_vtable0 vtbl_impl = {
        .ftbl_ptr_0 = &::ns_test::foo::weak::window::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&ns_test_foo_window_i0, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &ns_test_foo_window_i0;
    using vtable_t = ns_test_foo_window_vtable0;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace ns_test::foo {
struct window : public ::ns_test::foo::weak::window {
    static constexpr bool is_holder = true;
    explicit window(struct ns_test_foo_window_t0 handle) : ::ns_test::foo::weak::window(handle) {}
    window& operator=(::ns_test::foo::window other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~window() {
        ns_test_foo_window_drop0(m_handle);
    }
    explicit window(::taihe::data_holder other)
        : window(ns_test_foo_window_dynamic0(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct ns_test_foo_window_t0 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct ns_test_foo_window_t0 ret_handle = ns_test_foo_window_copy0(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct ns_test_foo_window_t0 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    window(::ns_test::foo::weak::window const& other)
        : window(ns_test_foo_window_copy0(other.m_handle)) {}
    window(::ns_test::foo::window const& other)
        : window(ns_test_foo_window_copy0(other.m_handle)) {}
    window(::ns_test::foo::window&& other)
        : window(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::ns_test::foo::window> {
    using type = struct ns_test_foo_window_t0;
};
template<>
struct as_abi<::ns_test::foo::weak::window> {
    using type = struct ns_test_foo_window_t0;
};
template<>
struct as_param<::ns_test::foo::window> {
    using type = ::ns_test::foo::weak::window;
};
}
