#include "overload.ani.hpp"
#include "overload.user.hpp"
static ani_int overload_sum_two_ANIFunc1([[maybe_unused]] ani_env *env, ani_int ani_arg_a, ani_int ani_arg_b) {
    ::taihe::set_env(env);
    int32_t cpp_arg_a = (int32_t)ani_arg_a;
    int32_t cpp_arg_b = (int32_t)ani_arg_b;
    int32_t cpp_result = ::overload::sum_two(cpp_arg_a, cpp_arg_b);
    if (::taihe::has_error()) { return ani_int{}; }
    ani_int ani_result = (int32_t)cpp_result;
    return ani_result;
}
static ani_int overload_sum_arr_ANIFunc1([[maybe_unused]] ani_env *env, ani_array_int ani_arg_a) {
    ::taihe::set_env(env);
    size_t cpp_arg_a_size;
    env->Array_GetLength(ani_arg_a, &cpp_arg_a_size);
    int32_t* cpp_arg_a_buffer = (int32_t*)malloc(cpp_arg_a_size * sizeof(int32_t));
    env->Array_GetRegion_Int(ani_arg_a, 0, cpp_arg_a_size, reinterpret_cast<ani_int*>(cpp_arg_a_buffer));
    ::taihe::array<int32_t> cpp_arg_a(cpp_arg_a_buffer, cpp_arg_a_size);
    int32_t cpp_result = ::overload::sum_arr(cpp_arg_a);
    if (::taihe::has_error()) { return ani_int{}; }
    ani_int ani_result = (int32_t)cpp_result;
    return ani_result;
}
namespace overload {
ani_status ANIRegister(ani_env *env) {
    {
        ani_module ani_env;
        if (ANI_OK != env->FindModule("Loverload;", &ani_env)) {
            return ANI_ERROR;
        }
        ani_native_function methods[] = {
            {"sum_two_inner", nullptr, reinterpret_cast<void*>(overload_sum_two_ANIFunc1)},

            {"sum_arr_inner", nullptr, reinterpret_cast<void*>(overload_sum_arr_ANIFunc1)},

        };
        if (ANI_OK != env->Module_BindNativeFunctions(ani_env, methods, sizeof(methods) / sizeof(ani_native_function))) {
            return ANI_ERROR;
        }
    }
    return ANI_OK;
}
}
