#pragma once
#include "taihe/object.hpp"
#include "hms.core.map.map_inner.Resource.proj.0.hpp"
#include "hms.core.map.map_inner.Resource.abi.1.h"
namespace hms::core::map::map_inner::weak {
struct Resource {
    static constexpr bool is_holder = false;
    struct hms_core_map_map_inner_Resource_t3 m_handle;
    explicit Resource(struct hms_core_map_map_inner_Resource_t3 handle) : m_handle(handle) {}
    explicit Resource(::taihe::data_view other)
        : Resource(hms_core_map_map_inner_Resource_dynamic3(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct hms_core_map_map_inner_Resource_t3 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct hms_core_map_map_inner_Resource_t3 ret_handle = hms_core_map_map_inner_Resource_copy3(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        void foo(int32_t a) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static void foo(struct hms_core_map_map_inner_Resource_t3 tobj, int32_t a);
    };
    template<typename Impl>
    static constexpr hms_core_map_map_inner_Resource_ftable3 ftbl_impl = {
        .foo = &methods_impl<Impl>::foo,
    };
    template<typename Impl>
    static constexpr hms_core_map_map_inner_Resource_vtable3 vtbl_impl = {
        .ftbl_ptr_0 = &::hms::core::map::map_inner::weak::Resource::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&hms_core_map_map_inner_Resource_i3, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &hms_core_map_map_inner_Resource_i3;
    using vtable_t = hms_core_map_map_inner_Resource_vtable3;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace hms::core::map::map_inner {
struct Resource : public ::hms::core::map::map_inner::weak::Resource {
    static constexpr bool is_holder = true;
    explicit Resource(struct hms_core_map_map_inner_Resource_t3 handle) : ::hms::core::map::map_inner::weak::Resource(handle) {}
    Resource& operator=(::hms::core::map::map_inner::Resource other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~Resource() {
        hms_core_map_map_inner_Resource_drop3(m_handle);
    }
    explicit Resource(::taihe::data_holder other)
        : Resource(hms_core_map_map_inner_Resource_dynamic3(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct hms_core_map_map_inner_Resource_t3 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct hms_core_map_map_inner_Resource_t3 ret_handle = hms_core_map_map_inner_Resource_copy3(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct hms_core_map_map_inner_Resource_t3 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    Resource(::hms::core::map::map_inner::weak::Resource const& other)
        : Resource(hms_core_map_map_inner_Resource_copy3(other.m_handle)) {}
    Resource(::hms::core::map::map_inner::Resource const& other)
        : Resource(hms_core_map_map_inner_Resource_copy3(other.m_handle)) {}
    Resource(::hms::core::map::map_inner::Resource&& other)
        : Resource(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::hms::core::map::map_inner::Resource> {
    using type = struct hms_core_map_map_inner_Resource_t3;
};
template<>
struct as_abi<::hms::core::map::map_inner::weak::Resource> {
    using type = struct hms_core_map_map_inner_Resource_t3;
};
template<>
struct as_param<::hms::core::map::map_inner::Resource> {
    using type = ::hms::core::map::map_inner::weak::Resource;
};
}
