#pragma once
#include "hms.core.map.map_inner.icons_type.ani.0.h"
#include "hms.core.map.map_inner.icons_type.proj.1.hpp"
#include "hms.core.map.map_inner.Resource.ani.1.h"
inline ::hms::core::map::map_inner::icons_type hms_core_map_map_inner_icons_type_fromANI32(ani_env* env, ani_ref ani_value) {
    ani_class ani_cls_type_string;
    env->FindClass("Lstd/core/String;", &ani_cls_type_string);
    ani_boolean ani_is_type_string;
    env->Object_InstanceOf((ani_object)ani_value, ani_cls_type_string, &ani_is_type_string);
    if (ani_is_type_string) {
        ani_size cpp_field_type_string_len;
        env->String_GetUTF8Size(static_cast<ani_string>(ani_value), &cpp_field_type_string_len);
        TString cpp_field_type_string_tstr;
        char* cpp_field_type_string_buf = tstr_initialize(&cpp_field_type_string_tstr, cpp_field_type_string_len + 1);
        env->String_GetUTF8(static_cast<ani_string>(ani_value), cpp_field_type_string_buf, cpp_field_type_string_len + 1, &cpp_field_type_string_len);
        cpp_field_type_string_buf[cpp_field_type_string_len] = '\0';
        cpp_field_type_string_tstr.length = cpp_field_type_string_len;
        taihe::string cpp_field_type_string = taihe::string(cpp_field_type_string_tstr);
        return ::hms::core::map::map_inner::icons_type(taihe::static_tag<::hms::core::map::map_inner::icons_type::tag_t::type_string>, std::move(cpp_field_type_string));
    }
    ani_class ani_cls_type_Resource;
    env->FindClass("L@hms/core/map/map_inner/Resource;", &ani_cls_type_Resource);
    ani_boolean ani_is_type_Resource;
    env->Object_InstanceOf((ani_object)ani_value, ani_cls_type_Resource, &ani_is_type_Resource);
    if (ani_is_type_Resource) {
        ::hms::core::map::map_inner::Resource cpp_field_type_Resource = hms_core_map_map_inner_Resource_fromANI3(env, static_cast<ani_object>(ani_value));
        return ::hms::core::map::map_inner::icons_type(taihe::static_tag<::hms::core::map::map_inner::icons_type::tag_t::type_Resource>, std::move(cpp_field_type_Resource));
    }
    ani_class ani_cls_type_Image;
    env->FindClass("Lstd/core/Object;", &ani_cls_type_Image);
    ani_boolean ani_is_type_Image;
    env->Object_InstanceOf((ani_object)ani_value, ani_cls_type_Image, &ani_is_type_Image);
    if (ani_is_type_Image) {
        uintptr_t cpp_field_type_Image = (uintptr_t)static_cast<ani_ref>(ani_value);
        return ::hms::core::map::map_inner::icons_type(taihe::static_tag<::hms::core::map::map_inner::icons_type::tag_t::type_Image>, std::move(cpp_field_type_Image));
    }
    __builtin_unreachable();
}
inline ani_ref hms_core_map_map_inner_icons_type_intoANI32(ani_env* env, ::hms::core::map::map_inner::icons_type const& cpp_value) {
    ani_ref ani_value;
    switch (cpp_value.get_tag()) {
    case ::hms::core::map::map_inner::icons_type::tag_t::type_string: {
        ani_string ani_field_type_string;
        env->String_NewUTF8(cpp_value.get_type_string_ref().c_str(), cpp_value.get_type_string_ref().size(), &ani_field_type_string);
        ani_value = ani_field_type_string;
        break;
    }
    case ::hms::core::map::map_inner::icons_type::tag_t::type_Resource: {
        ani_object ani_field_type_Resource = hms_core_map_map_inner_Resource_intoANI3(env, cpp_value.get_type_Resource_ref());
        ani_value = ani_field_type_Resource;
        break;
    }
    case ::hms::core::map::map_inner::icons_type::tag_t::type_Image: {
        ani_ref ani_field_type_Image = (ani_ref)cpp_value.get_type_Image_ref();
        ani_value = ani_field_type_Image;
        break;
    }
    }
    return ani_value;
}
