#pragma once
#include "taihe/object.hpp"
#include "hms.core.map.map_inner.map_inner.proj.0.hpp"
#include "hms.core.map.map_inner.map_inner.abi.1.h"
#include "taihe/string.hpp"
#include "taihe/array.hpp"
#include "hms.core.map.map_inner.icons_type.proj.0.hpp"
#include "hms.core.map.map_inner.Resource.proj.0.hpp"
namespace hms::core::map::map_inner::weak {
struct map_inner {
    static constexpr bool is_holder = false;
    struct hms_core_map_map_inner_map_inner_t32 m_handle;
    explicit map_inner(struct hms_core_map_map_inner_map_inner_t32 handle) : m_handle(handle) {}
    explicit map_inner(::taihe::data_view other)
        : map_inner(hms_core_map_map_inner_map_inner_dynamic32(other.data_ptr)) {}
    operator ::taihe::data_view() const& {
        struct hms_core_map_map_inner_map_inner_t32 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct hms_core_map_map_inner_map_inner_t32 ret_handle = hms_core_map_map_inner_map_inner_copy32(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    struct virtual_type {
        ::taihe::string getId() const&;
        int32_t getZIndex() const&;
        int32_t getMaxZoom() const&;
        int32_t getMinZoom() const&;
        int32_t setIcons_sync(::taihe::array_view<::hms::core::map::map_inner::icons_type> icons) const&;
        void setPositions(::taihe::array_view<::taihe::array<::hms::core::map::map_inner::Resource>> positions) const&;
    };
    template<typename Impl>
    struct methods_impl {
        static struct TString getId(struct hms_core_map_map_inner_map_inner_t32 tobj);
        static int32_t getZIndex(struct hms_core_map_map_inner_map_inner_t32 tobj);
        static int32_t getMaxZoom(struct hms_core_map_map_inner_map_inner_t32 tobj);
        static int32_t getMinZoom(struct hms_core_map_map_inner_map_inner_t32 tobj);
        static int32_t setIcons_sync(struct hms_core_map_map_inner_map_inner_t32 tobj, struct TArray icons);
        static void setPositions(struct hms_core_map_map_inner_map_inner_t32 tobj, struct TArray positions);
    };
    template<typename Impl>
    static constexpr hms_core_map_map_inner_map_inner_ftable32 ftbl_impl = {
        .getId = &methods_impl<Impl>::getId,
        .getZIndex = &methods_impl<Impl>::getZIndex,
        .getMaxZoom = &methods_impl<Impl>::getMaxZoom,
        .getMinZoom = &methods_impl<Impl>::getMinZoom,
        .setIcons_sync = &methods_impl<Impl>::setIcons_sync,
        .setPositions = &methods_impl<Impl>::setPositions,
    };
    template<typename Impl>
    static constexpr hms_core_map_map_inner_map_inner_vtable32 vtbl_impl = {
        .ftbl_ptr_0 = &::hms::core::map::map_inner::weak::map_inner::template ftbl_impl<Impl>,
    };
    template<typename Impl>
    static constexpr IdMapItem idmap_impl[1] = {
        {&hms_core_map_map_inner_map_inner_i32, &vtbl_impl<Impl>.ftbl_ptr_0},
    };
    static constexpr void const* iid = &hms_core_map_map_inner_map_inner_i32;
    using vtable_t = hms_core_map_map_inner_map_inner_vtable32;
    explicit operator bool() const& { return m_handle.vtbl_ptr; }
    virtual_type const& operator*() const& {
        return *reinterpret_cast<virtual_type const*>(&m_handle);
    }
    virtual_type const* operator->() const& {
        return reinterpret_cast<virtual_type const*>(&m_handle);
    }
};
}
namespace hms::core::map::map_inner {
struct map_inner : public ::hms::core::map::map_inner::weak::map_inner {
    static constexpr bool is_holder = true;
    explicit map_inner(struct hms_core_map_map_inner_map_inner_t32 handle) : ::hms::core::map::map_inner::weak::map_inner(handle) {}
    map_inner& operator=(::hms::core::map::map_inner::map_inner other) {
        ::std::swap(m_handle, other.m_handle);
        return *this;
    }
    ~map_inner() {
        hms_core_map_map_inner_map_inner_drop32(m_handle);
    }
    explicit map_inner(::taihe::data_holder other)
        : map_inner(hms_core_map_map_inner_map_inner_dynamic32(other.data_ptr)) {
        other.data_ptr = nullptr;
    }
    operator ::taihe::data_view() const& {
        struct hms_core_map_map_inner_map_inner_t32 ret_handle = m_handle;
        return ::taihe::data_view(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() const& {
        struct hms_core_map_map_inner_map_inner_t32 ret_handle = hms_core_map_map_inner_map_inner_copy32(m_handle);
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    operator ::taihe::data_holder() && {
        struct hms_core_map_map_inner_map_inner_t32 ret_handle = m_handle;
        m_handle.data_ptr = nullptr;
        return ::taihe::data_holder(ret_handle.data_ptr);
    }
    map_inner(::hms::core::map::map_inner::weak::map_inner const& other)
        : map_inner(hms_core_map_map_inner_map_inner_copy32(other.m_handle)) {}
    map_inner(::hms::core::map::map_inner::map_inner const& other)
        : map_inner(hms_core_map_map_inner_map_inner_copy32(other.m_handle)) {}
    map_inner(::hms::core::map::map_inner::map_inner&& other)
        : map_inner(other.m_handle) {
        other.m_handle.data_ptr = nullptr;
    }
};
}
namespace taihe {
template<>
struct as_abi<::hms::core::map::map_inner::map_inner> {
    using type = struct hms_core_map_map_inner_map_inner_t32;
};
template<>
struct as_abi<::hms::core::map::map_inner::weak::map_inner> {
    using type = struct hms_core_map_map_inner_map_inner_t32;
};
template<>
struct as_param<::hms::core::map::map_inner::map_inner> {
    using type = ::hms::core::map::map_inner::weak::map_inner;
};
}
